#!/usr/bin/perl
##########
#
#  Bandley3.com's 5 Star Rating v3.0
#  Apache-Mac Apache-PC tested
#  Copyright 2000-2002 Bandley3.com
#  http://bandley3.com
#  cfs@mac.com
#
##########
#
#  Licensing Agreement
#
#  Purchasing a license and/or installing this script constitutes
#  acceptance of the licensing agreement you read before purchasing
#  said license. This agreement can be found at Bandley3.com and in
#  the README.Stars document packaged with this script.
#  Bandley3.com's 5 Star Rating is licensed, not sold.
#
#
##########

########## do not alter the following block of code
$ENV{'QUERY_STRING'} =~ s/\|//g;
$ENV{'QUERY_STRING'} =~ s/\x00//g;
$ENV{'QUERY_STRING'} =~ s/\%00//g;
$ENV{'QUERY_STRING'} =~ s/\.\.\///g;
$ENV{'QUERY_STRING'} =~ s/\%2E//ig;
$ENV{'QUERY_STRING'} =~ s/\%2F//ig;
########## end of block

#The root path of the sconfig.pl, including the sconfig.pl name itself.
$config_path="/home/sites/432a/stars/sconfig.pl";

#The root path of the directory that contains the password file (checkp.txt).
#NOTE: This file is encrypted, but for highest security, place it in a
#password protected directory.
#IMPORTANT: No trailing slash at the end of this path.
$check_pass="/home/sites/432a/stars";

#The URL of this Admin Script, including the script name itself.
#NOTE: For highest security, place this Admin Script in a
#protected cgi-bin or password protected directory.
$script_url="http://youdomain.com/cgi-bin/stars/sadmin.pl";

#Valid Referer
$vref="no";

#Valid Referer Address (if yes to above) - your domain.
#Don't forget the .com, .net, etc.
#And don't include a trailing slash following .com
$vrefcom="yourdomain.com";



########## No editing necessary below this point

require "$config_path";


if (!$ENV{'QUERY_STRING'}) {
     &getpass2;
}

elsif ($ENV{'QUERY_STRING'} eq 'setup') {
     &getpass;
}

elsif ($ENV{'QUERY_STRING'} eq 'changepass') {
     &checkreferer;
     &changepass;
}

elsif ($ENV{'QUERY_STRING'} eq 'unamepword2') {
     &checkreferer;
     &checkpass;
     &getprefp1;
}

elsif ($ENV{'QUERY_STRING'} eq 'getprefs') {
     &getprefs;
}

elsif ($ENV{'QUERY_STRING'} eq 'getprefp1') {
     &checkpass;
     &getprefp1;
}

elsif ($ENV{'QUERY_STRING'} eq 'getprefp1b') {
     &checkreferer;
     &checkpass;
     &getprefp1b;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp2') {
     &checkpass;
     &getprefp2;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp2b') {
     &checkreferer2;
     &checkpass;
     &getprefp2b;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp2c') {
     &checkpass;
     &getprefp2c;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp2d') {
     &checkreferer2;
     &checkpass;
     &getprefp2d;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp2e') {
     &checkreferer2;
     &checkpass;
     &getprefp2e;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp3') {
     &checkpass;
     &getprefp3;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp3b') {
     &checkreferer2;
     &checkpass;
     &getprefp3b;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp4') {
     &checkpass;
     &getprefp4;
}
elsif ($ENV{'QUERY_STRING'} eq 'getprefp4b') {
     &checkreferer2;
     &checkpass;
     &getprefp4b;
}

else {
     &errorit;
}

##########parseform

sub parseform {
 
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($key, $value) = split(/=/, $pair);
$key =~ tr/+/ /;
$key =~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~s/<!--(.|\n)*-->//g;
$value =~s/"//g;
$value =~ s/\|//g;
$value =~ s/\x00//g;
$value =~ s/\%00//g;
$value =~ s/\.\.\///g;
$value =~ s/\%2E//ig;
$value =~ s/\%2F//ig;
$FORM{$key} = $value;

if (!$FORM{'dishtml'}) {
$value =~s/;//g;
$FORM{$key} = $value;

     if ($FORM{'cretxt'}) {
     $FORM{'cretxt'} =~s/\s//g;

     }
}
}

}

##########getpass

sub getpass {

opendir (DIRP, "$check_pass") || &errorfile;
@dirp = readdir (DIRP);
closedir (DIRP);

$checker="checkp.txt";

foreach $dirp (@dirp) {

     if ($dirp eq $checker) {

    print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?changepass\" method=POST><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>\n";
     print "To Setup or Change your username and/or password, complete the form below.</b></font><font face=\"verdana\" size=\"2\" color=\"#000000\"><b><br><br>\n";
     print "If you do not want to Setup or Change your username and/or password, ignore the form below and re-enter the script.<br><br><font color=\"red\">$script_url</font><br><br><br>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"red\"><b>Username and Password are case sensitive.</b></font><br><br><br>\n";

     print "</b></font><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>CURRENT username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"cuname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"cpword\" size=\"10\"><br><br><br>\n";

     print "Please enter NEW username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br>\n";

     print "<input type=\"submit\" value=\"Submit Change\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
 }
}

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><font face=\"verdana\" size=\"2\" color=\"#000000\"><b><br><br>Cannot find password file <font color=\"red\">(checkp.txt)</font> in the directory <font color=\"red\">$check_pass</font><br><br><br>\n";
     print "Make sure <font color=\"red\">\$check_pass</font> variable in <font color=\"red\">sadmin.pl</font> is correct.<br><br>Make sure the <font color=\"red\">checkp.txt</font> is properly chmoded.</b></font></center>\n";
     print "</body></html>\n";

exit;

}

##########getpass2

sub getpass2 {

opendir (DIRP, "$check_pass") || &errorfile;
@dirp = readdir (DIRP);
closedir (DIRP);

$checker="checkp.txt";

foreach $dirp (@dirp) {

     if ($dirp eq $checker) {

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?unamepword2\" method=POST><font face=\"verdana\" size=\"2\" color=\"#000000\"><b><br><br>Enter username and password.<br><br>\n";
     print "Username and Password are case sensitive.<br><br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br><input type=\"submit\" value=\"Submit\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
 }
}
     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><font face=\"verdana\" size=\"2\" color=\"#000000\"><b><br><br>Cannot find password file <font color=\"red\">(checkp.txt)</font> in the directory <font color=\"red\">$check_pass</font><br><br><br>\n";
     print "Make sure <font color=\"red\">\$check_pass</font> variable in <font color=\"red\">sadmin.pl</font> is correct.<br><br>Make sure the <font color=\"red\">checkp.txt</font> is properly chmoded.</b></font></center>\n";
     print "</body></html>\n";
exit;

}
##########checkreferer

sub checkreferer {
     $checkref=0;

if ($vref eq "yes") {
$stref=$vrefcom;
$stref =~ s/^(www\.)//i;
if ($ENV{'HTTP_REFERER'} =~m|https?://www\.$stref|i || $ENV{'HTTP_REFERER'} =~m|https?://$stref|i) {
     $checkref=1;
}
  }
elsif ($vref eq "no") {
     $checkref=1;
  }
if ($checkref eq "0") {
     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?unamepword2\" method=POST><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>Username and/or Password are incorrect or need to be re-entered.\n";
     print "<br><br>Possible bad referer info in sadmin.pl\n";
     print "<br><br>\n";
     print "Username and Password are case sensitive.<br><br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br><input type=\"submit\" value=\"Submit\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
  }
}

##########checkreferer2

sub checkreferer2 {
     $checkref=0;

if ($vref eq "yes") {
$stref=$vrefcom;
$stref =~ s/^(www\.)//i;
if ($ENV{'HTTP_REFERER'} =~m|https?://www\.$stref|i || $ENV{'HTTP_REFERER'} =~m|https?://$stref|i) {
     $checkref=1;
}
     $checkref=1;
##### begin file locking trap
if ($FLOCKIT eq "yes") {
     open (DATA, "<$config_path") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATA, 2;
}
if ($FLOCKIT eq "yes") {
flock DATA, 8;
}
close(DATA);
}
##### end file locking trap
  }
elsif ($vref eq "no") {
     $checkref=1;
##### begin file locking trap
if ($FLOCKIT eq "yes") {
     open (DATA, "<$config_path") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATA, 2;
}
if ($FLOCKIT eq "yes") {
flock DATA, 8;
}
close(DATA);
}
##### end file locking trap
  }
if ($checkref eq "0") {
##### begin file locking trap
if ($FLOCKIT eq "yes") {
     open (DATA, "<$config_path") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATA, 2;
}
if ($FLOCKIT eq "yes") {
flock DATA, 8;
}
close(DATA);
}
##### end file locking trap
     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?unamepword2\" method=POST><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>Username and/or Password are incorrect or need to be re-entered.\n";
     print "<br><br>Possible bad referer info in sadmin.pl\n";
     print "<br><br>\n";
     print "Username and Password are case sensitive.<br><br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br><input type=\"submit\" value=\"Submit\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
  }
}


##########changepass

sub changepass {

     &parseform;

if (!$FORM{'uname'}) {

    print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?changepass\" method=POST><font face=\"verdana\" size=\"2\" color=\"red\"><b>Username cannot be blank.<br><br>\n";
     print "<font color=\"#000000\">If you would like to change your username and/or password, complete the form below.<br><br>\n";
     print "If not, re-enter the script by typing the URL to the sadmin.pl in your browser's location box.</font><br><br>$script_url<br><br><br>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"red\"><b>Username and Password are case sensitive.</b></font><br><br><br>\n";
     print "</b></font><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>CURRENT username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"cuname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"cpword\" size=\"10\"><br><br><br>\n";

     print "Please enter NEW username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br>\n";

     print "<input type=\"submit\" value=\"Submit Change\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
 }

if (!$FORM{'pword'}) {

    print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?changepass\" method=POST><font face=\"verdana\" size=\"2\" color=\"red\"><b>Password cannot be blank.<br><br>\n";
     print "<font color=\"#000000\">If you would like to change your username and/or password, complete the form below.<br><br>\n";
     print "If not, re-enter the script by typing the URL to the sadmin.pl in your browser's location box.</font><br><br>$script_url<br><br><br>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"red\"><b>Username and Password are case sensitive.</b></font><br><br><br>\n";
     print "</b></font><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>CURRENT username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"cuname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"cpword\" size=\"10\"><br><br><br>\n";

     print "Please enter NEW username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br>\n";

     print "<input type=\"submit\" value=\"Submit Change\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
 }


     open (DATAP, "<$check_pass/checkp.txt") || &errorfile;
@datap=split(';', <DATAP>);
close (DATAP);

$datana="$datap[0]";
$datapa="$datap[1]";
$cename = "$FORM{'cpword'}";
$cencname = crypt $cename, "SJ";

if (($FORM{'cuname'} eq $datana) && ($cencname eq $datapa)) {

     open (DATAP, ">$check_pass/checkp.txt") || &errorfile;

$ename = "$FORM{'pword'}";
$encname = crypt $ename, "SJ";

print DATAP "$FORM{'uname'};$encname";

close (DATAP);

&getpref;
}

else {

    print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?changepass\" method=POST><font face=\"verdana\" size=\"2\" color=\"red\"><b><br><br>CURRENT username and password are incorrect.<br><br>\n";
     print "<font color=\"#000000\">If this is not the page you wanted to be on</font> (like via a reload)<font color=\"#000000\">, ignore the form below and re-enter the script.</font><br><br>$script_url<br><br>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"red\"><b>Username and Password are case sensitive.</b></font><br><br><br>\n";
     print "</b></font><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>Username: <input type=\"text\" name=\"cuname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"cpword\" size=\"10\"><br><br><br>\n";

     print "Please enter NEW username and password.<br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br>\n";

     print "<input type=\"submit\" value=\"Submit Change\"></b></font></form></center>\n";
     print "</body></html>\n";
}

exit;
}


##########checkpass

sub checkpass {

&parseform;

     open (DATAP, "<$check_pass/checkp.txt") || &errorfile;
@datap=split(';', <DATAP>);
close (DATAP);

$ename = "$FORM{'pword'}";
$encname = crypt $ename, "SJ";

if (($FORM{'uname'} eq $datap[0]) && ($encname eq $datap[1])) {
$checkit=1;
}
else {

opendir (DIRP, "$check_pass") || &errorfile;
@dirp = readdir (DIRP);
closedir (DIRP);

$checker="checkp.txt";

foreach $dirp (@dirp) {

     if ($dirp eq $checker) {

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFFF\">\n";
     print "<center><form action=\"$script_url?unamepword2\" method=POST><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>Username and/or Password are incorrect or need to be re-entered.\n";
     print "<br><br>\n";
     print "Username and Password are case sensitive.<br><br><br>\n";
     print "Username: <input type=\"text\" name=\"uname\" size=\"10\"><br><br>\n";
     print "Password: <input type=\"text\" name=\"pword\" size=\"10\"><br><br><input type=\"submit\" value=\"Submit\"></b></font></form></center>\n";
     print "</body></html>\n";
exit;
 }
}

 }
}

##########getprefs

sub getprefs {

&parseform;


if ($FORM{'getprefs'} eq "getprefp1") {
     &getprefp1;
}
elsif ($FORM{'getprefs'} eq "getprefp2") {
     &getprefp2;
}
elsif ($FORM{'getprefs'} eq "getprefp3") {
     &getprefp3;
}
elsif ($FORM{'getprefs'} eq "getprefp4") {
     &getprefp4;
}
else {
&getpass2;
 }
}

##########getprefhead

sub getprefhead {

if ($FORM{'getprefs'} eq "getprefp1") {
$gsel1="SELECTED";
}
if ($FORM{'getprefs'} eq "getprefp2") {
$gsel2="SELECTED";
}
if ($FORM{'getprefs'} eq "getprefp3") {
$gsel3="SELECTED";
}
if ($FORM{'getprefs'} eq "getprefp4") {
$gsel4="SELECTED";
}

     print "<center><form action=\"$script_url?getprefs\" method=\"POST\">\n";
     print "<select name=\"getprefs\"><option name=\"getprefs\" value=\"getprefp1\" $gsel1>Pref Page 1 - Setup Paths / Check IP\n";
     print "<option name=\"getprefs\" value=\"getprefp2\" $gsel2>Pref Page 2 - Edit / Create / Hide Topics\n";
     print "<option name=\"getprefs\" value=\"getprefp3\" $gsel3>Pref Page 3 - Main \& Rate page\n";
     print "<option name=\"getprefs\" value=\"getprefp4\" $gsel4>Pref Page 4 - Single Topic page\n";
     print "</select><input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\"><br>\n";
     print "<input type=\"submit\" value=\"Select \& Go\"></form></center>\n";
}

##########getpref

sub getpref {

if ($VALIDREF eq "yes") {
     $selec1="SELECTED";
}
else {
     $selec11="SELECTED";
}
if ($CHECKIP eq "yes") {
     $selec2="SELECTED";
}
else {
     $selec22="SELECTED";
}
if ($FLOCKIT eq "yes") {
     $selec100a="SELECTED";
}
else {
     $selec100b="SELECTED";
}

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>If you need to see a <a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a> of this script, click here. (Will open in a new window)<br><br>\n";
     print "If you need <a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a>, click here. (Will open in a new window)<br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages1 and 2.<br><br>\n";

&getprefhead;

print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 1 - Setup \& Check IP</b></font></center><hr>\n";
print "<table width=\"100%\"><td>\n";
print "<form action=\"$script_url?getprefp1b\" method=\"POST\">\n";
print "<font face=\"verdana\" size=\"2\">\n";
print "URL of stars.pl script<br>ex. - http://yourdomain.com/stars/stars.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl\" value=\"$SCRIPTURL\"><br><br>\n";
print "URL of stars2.pl script<br>ex. - http://yourdomain.com/stars/stars2.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl2\" value=\"$SCRIPTURL2\"><br><br>\n";
print "URL Path to star images - <font color=\"blue\">no trailing slash</font>.<br>ex. - http://yourdomain.com/stars/starimages<br>\n";
print "<input type=\"text\" size=\"45\" name=\"imgpath\" value=\"$IMGPATH\"><br><br>\n";
print "Root path to sdata folder - <font color=\"blue\">no trailing slash</font>.<br>ex. - /home/web/sites423a/stars/sdata<br>\n";
print "NOTE: This folder contains the data files for each topic.<br>\n";
print "The actual files are created on Preference Page 2.<br>\n";
print "<input type=\"text\" size=\"45\" name=\"datapath\" value=\"$DATAPATH\"><br><br>\n";
print "Root path to slist, shlist, and stlist .txt files - <font color=\"blue\">no trailing slash</font><br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"listpath\" value=\"$LISTPATH\"><br><br>\n";
print "Root path to Header and Footer text files - <font color=\"blue\">no trailing slash</font>.<br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"headpath\" value=\"$HEADPATH\"><br><br>\n";
print "Valid Referer: \"Yes\" allows the stars.pl script to only be called from your domain. \n";
print "For security, yes is recommended.<br>\n";
print "<select name=\"validref\"><option name=\"validref\" value=\"yes\" $selec1>yes<option name=\"validref\" value=\"no\" $selec11>no</select><br><br>\n";
print "Valid Referer Domain: If yes to above,<br>\n";
print "this is the Domain name this script will be used on.<br>\n";
print "Don't forget the .com, .net, etc.<br>ex. - yourdomain.com<br>\n";
print "<input type=\"text\" name=\"validreferer\" value=\"$VALIDREFERER\"><br><br>\n";
print "Check IP: \"Yes\" means only one rating per user per topic.<br>\n";
print "<select name=\"checkip\"><option name=\"checkip\" value=\"yes\" $selec2>yes<option name=\"checkip\" value=\"no\" $selec22>no</select><br><br>\n";

print "File Locking: Will cause errors and possibly, permanently jumble data files if not supported by server. \n";
print "Default set to off. Turn on ONLY if you know you can or to test. Only test when all data files are backed up. *See README.Stars for more info.<br>\n";
print "<select name=\"flockit\"><option name=\"flockit\" value=\"yes\" $selec100a>on<option name=\"flockit\" value=\"no\" $selec100b>off</select><br><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"Submit - Set Up Variables\"></form></font></td></table>\n";
     print "</td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}
##########getprefp1

sub getprefp1 {

if ($VALIDREF eq "yes") {
     $selec1="SELECTED";
}
else {
     $selec11="SELECTED";
}
if ($CHECKIP eq "yes") {
     $selec2="SELECTED";
}
else {
     $selec22="SELECTED";
}
if ($FLOCKIT eq "yes") {
     $selec100a="SELECTED";
}
else {
     $selec100b="SELECTED";
}

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"2\" color=\"#000000\"><b><a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a><br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a><br><br>\n";

&getprefhead;

     print "<br><br></b></font>\n";
print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 1 - Setup \& Check IP</b></font></center><hr>\n";
print "<table width=\"100%\"><td>\n";
print "<form action=\"$script_url?getprefp1b\" method=\"POST\">\n";
print "<font face=\"verdana\" size=\"2\">\n";
print "URL of stars.pl script<br>ex. - http://yourdomain.com/stars/stars.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl\" value=\"$SCRIPTURL\"><br><br>\n";
print "URL of stars2.pl script<br>ex. - http://yourdomain.com/stars/stars2.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl2\" value=\"$SCRIPTURL2\"><br><br>\n";
print "URL Path to star images - <font color=\"blue\">no trailing slash</font>.<br>ex. - http://yourdomain.com/stars/starimages<br>\n";
print "<input type=\"text\" size=\"45\" name=\"imgpath\" value=\"$IMGPATH\"><br><br>\n";
print "Root path to sdata folder - <font color=\"blue\">no trailing slash</font>.<br>ex. - /home/web/sites423a/stars/sdata<br>\n";
print "NOTE: This folder contains the data files for each topic.<br>\n";
print "The actual files are created on Preference Page 2.<br>\n";
print "<input type=\"text\" size=\"45\" name=\"datapath\" value=\"$DATAPATH\"><br><br>\n";
print "Root path to slist, shlist, and stlist .txt files - <font color=\"blue\">no trailing slash</font><br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"listpath\" value=\"$LISTPATH\"><br><br>\n";
print "Root path to Header and Footer text files - <font color=\"blue\">no trailing slash</font>.<br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"headpath\" value=\"$HEADPATH\"><br><br>\n";
print "Valid Referer: \"Yes\" allows the stars.pl script to only be called from your domain. \n";
print "For security, yes is recommended.<br>\n";
print "<select name=\"validref\"><option name=\"validref\" value=\"yes\" $selec1>yes<option name=\"validref\" value=\"no\" $selec11>no</select><br><br>\n";
print "Valid Referer Domain: If yes to above,<br>\n";
print "this is the Domain name this script will be used on.<br>\n";
print "Don't forget the .com, .net, etc.<br>ex. - yourdomain.com<br>\n";
print "<input type=\"text\" name=\"validreferer\" value=\"$VALIDREFERER\"><br><br>\n";
print "Check IP: \"Yes\" means only one rating per user per topic.<br>\n";
print "<select name=\"checkip\"><option name=\"checkip\" value=\"yes\" $selec2>yes<option name=\"checkip\" value=\"no\" $selec22>no</select><br><br>\n";

print "File Locking: Will cause errors and possibly, permanently jumble data files if not supported by server. \n";
print "Default set to off. Turn on ONLY if you know you can or to test. Only test when all data files are backed up. *See README.Stars for more info.<br>\n";
print "<select name=\"flockit\"><option name=\"flockit\" value=\"yes\" $selec100a>on<option name=\"flockit\" value=\"no\" $selec100b>off</select><br><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

print "<input type=\"submit\" value=\"SUBMIT CHANGES\"></form></font></td></table>\n";
     print "</td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}

##########getprefp1b

sub getprefp1b {

&parseform;

     open (DATAFILE, "<$config_path") || &errorfile;
@dataline=<DATAFILE>;
foreach $datafi(@dataline) {
chomp ($datafi);
}
close (DATAFILE);


     if (!$FORM{'scripturl'}) {
    $rederror2=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'scripturl2'}) {
    $rederror3=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'imgpath'}) {
    $rederror4=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'datapath'}) {
    $rederror5=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'listpath'}) {
    $rederror6=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'headpath'}) {
    $rederror7=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }
     if (!$FORM{'validreferer'}) {
    $rederror8=" - <font color\=red>This field is blank or contains an error</font>";
     &getpreferror;
 }


     open (DATAFILE, ">$config_path") || &errorfile;

print DATAFILE "\$SITENAME=\"Bandley3\"\;\n";
print DATAFILE "\$SCRIPTURL=\"$FORM{'scripturl'}\"\;\n";
print DATAFILE "\$SCRIPTURL2=\"$FORM{'scripturl2'}\"\;\n";
print DATAFILE "\$IMGPATH=\"$FORM{'imgpath'}\"\;\n";
print DATAFILE "\$DATAPATH=\"$FORM{'datapath'}\"\;\n";
print DATAFILE "\$LISTPATH=\"$FORM{'listpath'}\"\;\n";
print DATAFILE "\$HEADPATH=\"$FORM{'headpath'}\"\;\n";
print DATAFILE "\$VALIDREF=\"$FORM{'validref'}\"\;\n";
print DATAFILE "\$VALIDREFERER=\"$FORM{'validreferer'}\"\;\n";
print DATAFILE "\$CHECKIP=\"$FORM{'checkip'}\"\;\n";
print DATAFILE "\$STARSREVIEW=\"$STARSREVIEW\"\;\n";
print DATAFILE "\$SREVIEWPATH=\"$SREVIEWPATH\"\;\n";

@datanum=('12' .. '119');
$varpre="@dataline";

foreach $vari (@datanum) {

print DATAFILE "$dataline[$vari]\n";
}
print DATAFILE "\$FLOCKIT=\"$FORM{'flockit'}\"\;";

close (DATAFILE);

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>\n";
     print "Preference Page 1 - Setup \& Check IP have been UPDATED - if you receive Server Errors, it is most likely due to bad paths on previous page \n";
     print "or improper chmod permissions. See <a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a> for chmod information.<br><br></b></font>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a><br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a><br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";
  
&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}

##########getprefp2

sub getprefp2 {

     open (FILEL, "<$LISTPATH/slist.txt") || &errorfile;
@filef= split(';', <FILEL>);
close (FILEL);

     open (FILEU, "<$LISTPATH/shlist.txt") || &errorfile;
@fileu= split(';', <FILEU>);
close (FILEU);

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"2\" color=\"#000000\">\n";

&getprefhead;

     print "<br><br></b></font>\n";

print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 2 - Edit/Create/Hide Topics</b></font></center><hr>\n";

print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>To EDIT an existing topic,<br>Select and Go<br></b></font>\n";
     print "<form action=\"$script_url?getprefp2c\" method=\"POST\">\n";
     print "<select name=\"topedit\">\n";

foreach $filef (@filef) {

     print "<option name=\"topedit\" value=\"$filef\">$filef\n";
}

     print "</select>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<br><input type=\"submit\" value=\"Go\">\n";
     print "</form></center>\n";
print "<hr>\n";
print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>To CREATE a topic,<br>Fill out below.<br><br></b></font></center>\n";
     print "<font face=\"verdana\" size=\"2\"><b>NOTES: <font color=\"blue\">Except for the SINGLE TOPIC HTML, No Semicolons or Quotation Marks can be in any of the following fields.</font> Only 2 fields are required on this page: \"Name of Topic\" and \"One Word Name\". All other fields can be left blank.</b></font><br><br>\n";

print "<table width=\"100%\"><tr>\n";
print "<form action=\"$script_url?getprefp2b\" method=\"POST\"><td>\n";
     print "<font face=\"verdana\" size=\"2\">\n";
     print "Name of Topic - <font color=\"blue\">REQUIRED</font> <br>ex. - iMac DV Special Edition<br>\n";
     print "<input type=\"text\" name=\"cretop\"><br><br>\n";
     print "One Word Name - <font color=\"blue\">REQUIRED</font> <br>VERY IMPORTANT: Name MUST be ONE word (lowercase). Alpha-Numeric ONLY.\n";
     print " No symbols, spaces, periods, quotation marks, commas, or semicolons. This is a nickname used exclusively by the script. You needn't remember this name. 8 letters/numbers or less is recommended.<br>ex. - imacdv<br>\n";
     print "<input type=\"text\" name=\"cretxt\"><br><br>\n";
     print "Link Location - NOT required<br>NOTE: There are notes on Pref Pages 3 \& 4 explaining this variable in detail.\n";
     print " If you don't yet know what it is for, don't worry about it and just leave it blank.<br>\n";
     print "ex. - http://apple.com/imacs/imacdv.html<br>\n";
     print "<input type=\"text\" name=\"crelink\" size=\"40\"><br><br>\n";
     print " Title Text for Rating Page - NOT required<br>ex.- Rate the iMac DV<br>\n";
     print "<input type=\"text\" name=\"cretitle\"><br><br>\n";
     print " Description Text - NOT required<br><font color=\"blue\">Remember - No semicolons or quotation marks.</font><br>\n";
     print "<input type=\"text\" name=\"credesc\" size=\"40\"><br><br>\n";

     print " Single Topics html - NOT required<br>NOTE: If Single Topic pages are used, this is what will be displayed below Rating and above Footer. \n";
     print "Do not put in opening and closing &lt;html&gt; or &lt;body&gt; tags. That information is pulled from header2.txt and footer2.txt. Use &lt;br&gt; for carriage returns.\n";
     print " Using font tags will override font setting at bottom right of Pref Page 4.<br>\n";
     print "<textarea name=\"dishtml\" cols=50 rows=7 wrap=\"virtual\"></textarea><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"CREATE TOPIC\">\n";
     print "</font></td></form></tr></table><br><br><hr><center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>To HIDE or DELETE a Topic,<br>Select Topic and Click HIDE or DELETE<br></b></font>\n";

     print "<form action=\"$script_url?getprefp2e\" method=\"POST\">\n";
     print "<select name=\"tophide\">\n";

foreach $filef (@filef) {

     print "<option name=\"tophide\" value=\"$filef\">$filef\n";
}

     print "</select>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<br><br><input type=\"submit\" name=\"hideit\" value=\"HIDE\">&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"hideit\" value=\"DELETE\"><br><br><hr>\n";

     print "<font face=\"verdana\" size=\"3\" color=\"#000000\"><b>To UNHIDE a Topic,<br>Select Topic and Click UNHIDE<br><br></b></font> <select name=\"topunhide\">\n";

foreach $fileu (@fileu) {

     print "<option name=\"topunhide\" value=\"$fileu\">$fileu\n";
}

     print "</select>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<br><br><input type=\"submit\" name=\"hideit\" value=\"UNHIDE\">\n";



     print "</form></center>\n";
print "</td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}

##########getprefp2b

sub getprefp2b {

&parseform;

    $rederror22=" - <font color\=red>This field is blank or contains an error</font>";

if (!$FORM{'cretop'}) {

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>\n";
     print "Error: The \"Name of Topic\" field is blank.<br><br></b></font><br><br>\n";

     print "<font face=\"verdana\" size=\"2\"><b>Don't forget: no semicolons or quotation marks except Single Topic html.</b></font><br><br>\n";

print "<table width=\"100%\"><tr>\n";
print "<form action=\"$script_url?getprefp2b\" method=\"POST\"><td>\n";
     print "<font face=\"verdana\" size=\"2\">\n";
     print "Name of Topic - <font color=\"blue\">REQUIRED</font> $rederror22<br>ex. - iMac DV Special Edition<br>\n";
     print "<input type=\"text\" name=\"cretop\"><br><br>\n";
     print "One Word Name - <font color=\"blue\">REQUIRED</font> <br>VERY IMPORTANT: Name MUST be ONE word (lowercase). Alpha-Numeric ONLY.\n";
     print " No symbols, spaces, periods, quotation marks, commas, or semicolons. This is a nickname used exclusively by the script. You needn't remember this name. 8 letters/numbers or less is recommended.<br>ex. - imacdv<br>\n";
     print "<input type=\"text\" name=\"cretxt\" value=\"$FORM{'cretxt'}\"><br><br>\n";
     print "Link Location - NOT required<br>NOTE: There are notes on Pref Pages 3 \& 4 explaining this variable in detail.\n";
     print " If you don't yet know what it is for, don't worry about it and just leave it blank.<br>\n";
     print "ex. - http://apple.com/imacs/imacdv.html<br>\n";
     print "<input type=\"text\" name=\"crelink\" value=\"$FORM{'crelink'}\" size=\"40\"><br><br>\n";
     print " Title Text for Rating Page - NOT required<br>ex.- Rate the iMac DV<br>\n";
     print "<input type=\"text\" name=\"cretitle\" value=\"$FORM{'cretitle'}\"><br><br>\n";
     print " Description Text - NOT required<br><font color=\"blue\">Remember - No semicolons or quotation marks.</font>
<br>\n";
     print "<input type=\"text\" name=\"credesc\" value=\"$FORM{'credesc'}\" size=\"40\"><br><br><br>\n";

     print " Single Topics html - NOT required<br>NOTE: If Single Topic pages are used, this is what will be displayed below Rating and above Footer. \n";
     print "Do not put in opening and closing &lt;html&gt; or &lt;body&gt; tags. That information is pulled from header2.txt and footer2.txt. Use &lt;br&gt; for carriage returns.\n";
     print " Using font tags will override font setting at bottom right of Pref Page 4.<br>\n";
     print "<textarea name=\"dishtml\" cols=50 rows=7 wrap=\"virtual\">$FORM{'dishtml'}</textarea><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"SUBMIT CHANGES\">\n";
     print "</font></td></form></tr></table></td></table></center></body></html>\n";

exit;
}

if (!$FORM{'cretxt'}) {

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>\n";
     print "Error: The \"One Word Name\" field is blank.<br><br></b></font><br><br>\n";

     print "<font face=\"verdana\" size=\"2\"><b>Don't forget: no semicolons or quotation marks except Single Topic html.</b></font><br><br>\n";

print "<table width=\"100%\"><tr>\n";
print "<form action=\"$script_url?getprefp2b\" method=\"POST\"><td>\n";
     print "<font face=\"verdana\" size=\"2\">\n";
     print "Name of Topic - <font color=\"blue\">REQUIRED</font> <br>ex. - iMac DV Special Edition<br>\n";
     print "<input type=\"text\" name=\"cretop\" value=\"$FORM{'cretop'}\"><br><br>\n";
     print "One Word Name - <font color=\"blue\">REQUIRED</font> $rederror22<br>VERY IMPORTANT: Name MUST be ONE word (lowercase). Alpha-Numeric ONLY.\n";
     print " No symbols, spaces, periods, quotation marks, commas or semicolons. This is a nickname used exclusively by the script. You needn't remember this name. 8 letters/numbers or less is recommended.<br>ex. - imacdv<br>\n";
     print "<input type=\"text\" name=\"cretxt\"><br><br>\n";
     print "Link Location - NOT required<br>NOTE: There are notes on Pref Pages 3 \& 4 explaining this variable in detail.\n";
     print " If you don't yet know what it is for, don't worry about it and just leave it blank.<br>\n";
     print "ex. - http://apple.com/imacs/imacdv.html<br>\n";
     print "<input type=\"text\" name=\"crelink\" value=\"$FORM{'crelink'}\" size=\"40\"><br><br>\n";
     print " Title Text for Rating Page - NOT required<br>ex.- Rate the iMac DV<br>\n";
     print "<input type=\"text\" name=\"cretitle\" value=\"$FORM{'cretitle'}\"><br><br>\n";
     print " Description Text - NOT required<br><font color=\"blue\">Remember - No semicolons or quotation marks.</font>
<br>\n";
     print "<input type=\"text\" name=\"credesc\" value=\"$FORM{'credesc'}\" size=\"40\"><br><br><br>\n";

     print " Single Topics html - NOT required<br>NOTE: If Single Topic pages are used, this is what will be displayed below Rating and above Footer. \n";
     print "Do not put in opening and closing &lt;html&gt; or &lt;body&gt; tags. That information is pulled from header2.txt and footer2.txt. Use &lt;br&gt; for carriage returns.\n";
     print " Using font tags will override font setting at bottom right of Pref Page 4.<br>\n";
     print "<textarea name=\"dishtml\" cols=50 rows=7 wrap=\"virtual\">$FORM{'dishtml'}</textarea><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"SUBMIT CHANGES\">\n";
     print "</font></td></form></tr></table></td></table></center></body></html>\n";

exit;
}

#removed blank bug



     open (FILEE, "<$LISTPATH/slist.txt") || &errorfile;
@tisthere = split(';', <FILEE>);
close (FILEE);

foreach $desir (@tisthere) {

if ($FORM{'cretxt'} eq $desir) {

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>\n";
     print "Error: That \"One Word Name\" is already being used.<br><br></b></font><br><br>\n";

     print "<font face=\"verdana\" size=\"2\"><b>Don't forget: no semicolons or quotation marks except Single Topic html.</b></font><br><br>\n";

print "<table width=\"100%\"><tr>\n";
print "<form action=\"$script_url?getprefp2b\" method=\"POST\"><td>\n";
     print "<font face=\"verdana\" size=\"2\">\n";
     print "Name of Topic - <font color=\"blue\">REQUIRED</font> <br>ex. - iMac DV Special Edition<br>\n";
     print "<input type=\"text\" name=\"cretop\" value=\"$FORM{'cretop'}\"><br><br>\n";
     print "One Word Name - <font color=\"blue\">REQUIRED</font> $rederror22<br>VERY IMPORTANT: Name MUST be ONE word (lowercase). Alpha-Numeric ONLY.\n";
     print " No symbols, spaces, periods, quotation marks, commas, or semicolons. This is a nickname used exclusively by the script. You needn't remember this name. 8 letters/numbers or less is recommended.<br>ex. - imacdv<br>\n";
     print "<input type=\"text\" name=\"cretxt\" value=\"$FORM{'cretxt'}\"><br><br>\n";
     print "Link Location - NOT required<br>NOTE: There are notes on Pref Pages 3 \& 4 explaining this variable in detail.\n";
     print " If you don't yet know what it is for, don't worry about it and just leave it blank.<br>\n";
     print "ex. - http://apple.com/imacs/imacdv.html<br>\n";
     print "<input type=\"text\" name=\"crelink\" value=\"$FORM{'crelink'}\" size=\"40\"><br><br>\n";
     print " Title Text for Rating Page - NOT required<br>ex.- Rate the iMac DV<br>\n";
     print "<input type=\"text\" name=\"cretitle\" value=\"$FORM{'cretitle'}\"><br><br>\n";
     print " Description Text - NOT required<br><font color=\"blue\">Remember - No semicolons or quotation marks.</font>
<br>\n";
     print "<input type=\"text\" name=\"credesc\" value=\"$FORM{'credesc'}\" size=\"40\"><br><br><br>\n";

     print " Single Topics html - NOT required<br>NOTE: If Single Topic pages are used, this is what will be displayed below Rating and above Footer. \n";
     print "Do not put in opening and closing &lt;html&gt; or &lt;body&gt; tags. That information is pulled from header2.txt and footer2.txt. Use &lt;br&gt; for carriage returns.\n";
     print " Using font tags will override font setting at bottom right of Pref Page 4.<br>\n";
     print "<textarea name=\"dishtml\" cols=50 rows=7 wrap=\"virtual\">$FORM{'dishtml'}</textarea><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"SUBMIT CHANGES\">\n";
     print "</font></td></form></tr></table></td></table></center></body></html>\n";

exit;
}
}



     open (DATAM, ">$DATAPATH/$FORM{'cretxt'}.dat") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATAM, 2;
}

print DATAM "$FORM{'dishtml'}";

close (DATAM);


     open (DATAN, ">$DATAPATH/$FORM{'cretxt'}.txt") || &errorfile;

if ($FLOCKIT eq "yes") {
flock DATAN, 2;
}

print DATAN "$FORM{'cretop'};0;0;0;0;0;169.77.84.97;$FORM{'crelink'};$FORM{'cretitle'};$FORM{'credesc'}";

close (DATAN);


     open (FILEL, ">>$LISTPATH/slist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILEL, 2;
}
print FILEL "$FORM{'cretxt'};";

close (FILEL);


     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>\n";
     print "$FORM{'cretop'} has been Created!<br><br></b></font>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";

&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;

}

##########getprefp2c

sub getprefp2c {

&parseform;

     open (FILEY, "<$LISTPATH/shlist.txt") || &errorfile;
@filey = split(';', <FILEY>);
close (FILEY);

foreach $filey (@filey) {

if ($filey eq $FORM{'topedit'}) {
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>$FORM{'topedit'} must be unhidden before editing.</b></font>\n";
     &getprefhead;
     print "</center></body></html>\n";
exit;
}
}

     open (FILER, "<$DATAPATH/$FORM{'topedit'}.txt") || &errorfile;
@filer = split (';', <FILER>);
close (FILER);

open (DISHTML, "<$DATAPATH/$FORM{'topedit'}.dat") || &errorfile;
@dishtml = <DISHTML>;
close(DISHTML);


     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";

&getprefhead;

     print "<br><br></b></font>\n";

print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 2 - Edit/Create/Hide Topics</b></font></center><hr>\n";

print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b><br>EDIT - $filer[0]<br><br><br></b></font></center>\n";
     print "<font face=\"verdana\" size=\"2\"><b>NOTES: <font color=\"blue\">Except for the SINGLE TOPIC HTML, No Semicolons or Quotation Marks can be in any of the following fields.</font> \n";
     print "1 field is required on this page: \"Name of Topic.\" All other fields can be left blank.</b></font><br><br>\n";

$filer="$filer[0]";

print "<table width=\"100%\"><tr>\n";
print "<form action=\"$script_url?getprefp2d\" method=\"POST\"><td>\n";
     print "<font face=\"verdana\" size=\"2\">\n";
     print "Name of Topic - <font color=\"blue\">REQUIRED</font> <br>ex. - iMac DV Special Edition<br>\n";
     print "<input type=\"text\" name=\"cretop\" value=\"$filer\"><br><br>\n";
     print "<input type=\"hidden\" name=\"cretxt\" value=\"$FORM{'topedit'}\"><br><br>\n";

#removed blank bug

     print "Link Location - NOT required<br>NOTE: There are notes on Pref Pages 3 \& 4 explaining this variable in detail.\n";
     print " If you don't yet know what it is for, don't worry about it and just leave it blank.<br>If previously blank, default URL placed to avoid 404s.<br>\n";
     print "ex. - http://apple.com/imacs/imacdv.html<br>\n";
     print "<input type=\"text\" name=\"crelink\" value=\"$filer[7]\" size=\"40\"><br><br>\n";
     print " Title Text for Rating Page - NOT required<br>ex.- Rate the iMac DV<br>\n";
     print "<input type=\"text\" name=\"cretitle\" value=\"$filer[8]\"><br><br>\n";
     print " Description Text - NOT required<br><font color=\"blue\">Remember - No semicolons or quotation marks.</font>
<br>\n";
     print "<input type=\"text\" name=\"credesc\" value=\"$filer[9]\" size=\"40\"><br><br>\n";

     print " Single Topics html - NOT required<br>NOTE: If Single Topic pages are used, this is what will be displayed below Rating and above Footer. \n";
     print "Do not put in opening and closing &lt;html&gt; or &lt;body&gt; tags. That information is pulled from header2.txt and footer2.txt. Use &lt;br&gt; for carriage returns.\n";
     print " Using font tags will override font setting at bottom right of Pref Page 4.<br>\n";
     print "<textarea name=\"dishtml\" cols=50 rows=7 wrap=\"virtual\">@dishtml</textarea><br><br>\n";

     print "<font face=\"verdana\" size=\"2\">Rate Totals - IMPORTANT:<br>1) Changing the numbers below will erase the current Rate Totals for <font color=\"blue\">$filer[0]</font>.<br>\n";
     print "2) The Grand Total on your front page, if displayed, will reflect any changes made below.<br>\n"; 
     print "3) To reset Rate Totals for <font color=\"blue\">$filer[0]</font>, type zeroes or leave boxes blank.<br>\n";
     print "<table><tr><td colspan=\"5\" align=\"center\"></td></tr><tr>\n";
     print "<td align=\"center\"><input type=\"text\" name=\"val1\" value=\"$filer[1]\" size=\"3\"><br><font face=\"verdana\" size=\"2\" color=\"#000000\">1</font></td>\n";
     print "<td align=\"center\"><input type=\"text\" name=\"val2\" value=\"$filer[2]\" size=\"3\"><br><font face=\"verdana\" size=\"2\" color=\"#000000\">2</font></td>\n";
     print "<td align=\"center\"><input type=\"text\" name=\"val3\" value=\"$filer[3]\" size=\"3\"><br><font face=\"verdana\" size=\"2\" color=\"#000000\">3</font></td>\n";
     print "<td align=\"center\"><input type=\"text\" name=\"val4\" value=\"$filer[4]\" size=\"3\"><br><font face=\"verdana\" size=\"2\" color=\"#000000\">4</font></td>\n";
     print "<td align=\"center\"><input type=\"text\" name=\"val5\" value=\"$filer[5]\" size=\"3\"><br><font face=\"verdana\" size=\"2\" color=\"#000000\">5</font></td>\n";
     print "</td></tr></table>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<br><br><input type=\"submit\" value=\"SAVE CHANGES\">\n";
     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b><br><br><br>If you DO NOT want to save changes. You can use your browser's Back button or the links at the top of this page.\n";
     print "</font></td></form></tr></table>\n";
     print "<br><br><br></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}

##########getprefp2d

sub getprefp2d {

&parseform;

     open (FILEY, "<$DATAPATH/$FORM{'cretxt'}.dat") || &errorfile;
close (FILEY);


open (DISHTML, ">$DATAPATH/$FORM{'cretxt'}.dat") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DISHTML, 2;
}
     print DISHTML "$FORM{'dishtml'}";
close(DISHTML);


     open (FILER, "<$DATAPATH/$FORM{'cretxt'}.txt") || &errorfile;
@filer = split (';', <FILER>);
close (FILER);

$oldnumbers=$filer[1]+$filer[2]+$filer[3]+$filer[4]+$filer[5];

     open (FILESUM, "<$LISTPATH/stlist.txt") || &errorfile;
@filesum = <FILESUM>;
close (FILESUM);

$oldgrand=$filesum[0];
$newtotal=$oldgrand - $oldnumbers;
$newgrand=$newtotal+$FORM{'val1'}+$FORM{'val2'}+$FORM{'val3'}+$FORM{'val4'}+$FORM{'val5'};

     open (FILESUM, ">$LISTPATH/stlist.txt") || &errorfile;
print FILESUM "$newgrand";
close (FILESUM);



     open (FILIT, "<$DATAPATH/$FORM{'cretxt'}.txt") || &errorfile;
@filit = split (';', <FILIT>);
close (FILIT);

if (!$FORM{'cretop'}) {
     $FORM{'cretop'}=$filit[0];
}

#removed blank bug


if (!$FORM{'val1'}) {
     $FORM{'val1'}="0";
}
if (!$FORM{'val2'}) {
     $FORM{'val2'}="0";
}
if (!$FORM{'val3'}) {
     $FORM{'val3'}="0";
}
if (!$FORM{'val4'}) {
     $FORM{'val4'}="0";
}
if (!$FORM{'val5'}) {
     $FORM{'val5'}="0";
}
     open (FILIT, ">$DATAPATH/$FORM{'cretxt'}.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILIT, 2;
}

print FILIT "$FORM{'cretop'};$FORM{'val1'};$FORM{'val2'};$FORM{'val3'};$FORM{'val4'};$FORM{'val5'};169.77.84.97;$FORM{'crelink'};$FORM{'cretitle'};$FORM{'credesc'}";

close (FILIT);

     print "Content-type:text/html\n\n";

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>$FORM{'cretop'} has been UPDATED.<br><br></b></font>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";

&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";

exit;
}

##########getprefp2e

sub getprefp2e {

&parseform;

     print "Content-type:text/html\n\n";

if ($FORM{'hideit'} eq "HIDE") {


     open (FILEY, "<$LISTPATH/shlist.txt") || &errorfile;
@filey = split(';', <FILEY>);
close (FILEY);

foreach $filey (@filey) {

if ($filey eq $FORM{'tophide'}) {
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>$FORM{'tophide'} has already been hidden.</b></font>\n";
     &getprefhead;
     print "</center></body></html>\n";
exit;
}
}

     open (FILER, "<$DATAPATH/$FORM{'tophide'}.txt") || &errorfile;
@filer = split (';', <FILER>);
close (FILER);


     open (FILEL, "<$LISTPATH/slist.txt") || &errorfile;
@filef = split(';', <FILEL>);
close (FILEL);


$oldnumbers=$filer[1]+$filer[2]+$filer[3]+$filer[4]+$filer[5];

     open (FILESUM, "<$LISTPATH/stlist.txt") || &errorfile;
@filesum = <FILESUM>;
close (FILESUM);

$oldgrand=$filesum[0];
$newtotal=$oldgrand - $oldnumbers;

     open (FILESUM, ">$LISTPATH/stlist.txt") || &errorfile;
print FILESUM "$newtotal";
close (FILESUM);

     open (FILEL, ">$LISTPATH/slist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILEL, 2;
}

foreach $filef (@filef) {
     if ($filef ne $FORM{'tophide'}) {
     print FILEL "$filef;";
}
}
close (FILEL);

     open (FILEH, ">>$LISTPATH/shlist.txt") || &errorfile;
     print FILEH "$FORM{'tophide'};";
close (FILEH);

$filehide="$FORM{'tophide'} has been hidden.";
&headerhide;
exit;
}

if ($FORM{'hideit'} eq "DELETE") {


if (!$FORM{'tophide'}) {
&errorfile;
}

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td align=\"center\"><font face=\"verdana\" size=\"3\" color=\"#000000\"><b><br><br>Selecting \"DELETE\" will delete all data associated with <font color=\"blue\">$FORM{'tophide'}</font>. If you are sure you want to delete <font color=\"blue\">$FORM{'tophide'}</font> and it's data, select \"DELETE\".<br><br></b></font>\n";
     print "<form action=\"$script_url?getprefp2e\" method=\"POST\">\n";
     print "<input type=\"hidden\" name=\"hideit\" value=\"delnow\">\n";
     print "<input type=\"hidden\" name=\"tophide\" value=\"$FORM{'tophide'}\">\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

     print "<input type=\"submit\" value=\"DELETE\"><br><br><br></form>\n";
     print "<form><INPUT TYPE=\"Button\" VALUE=\"Back-DON'T DELETE\" onClick=\"history.back()\"></form></td></table></body></html>\n";
exit;
}

if ($FORM{'hideit'} eq "delnow") {

     open (FILEY, "<$LISTPATH/shlist.txt") || &errorfile;
@filey = split(';', <FILEY>);
close (FILEY);

foreach $filey (@filey) {

if ($filey eq $FORM{'tophide'}) {
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>$FORM{'tophide'} must be unhidden to be deleted.</b></font>\n";
     &getprefhead;
     print "</center></body></html>\n";
exit;
}
}

     open (FILEL, "<$LISTPATH/slist.txt") || &errorfile;
@filef = split(';', <FILEL>);
close (FILEL);

     open (FILER, "<$DATAPATH/$FORM{'tophide'}.txt") || &errorfile;
@filer = split (';', <FILER>);
close (FILER);

$oldnumbers=$filer[1]+$filer[2]+$filer[3]+$filer[4]+$filer[5];

     open (FILESUM, "<$LISTPATH/stlist.txt") || &errorfile;
@filesum = <FILESUM>;
close (FILESUM);

$oldgrand=$filesum[0];
$newtotal=$oldgrand - $oldnumbers;

     open (FILESUM, ">$LISTPATH/stlist.txt") || &errorfile;

print FILESUM "$newtotal";

close (FILESUM);

     open (FILEL, ">$LISTPATH/slist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILEL, 2;
}

foreach $filef (@filef) {
     if ($filef ne $FORM{'tophide'}) {
     print FILEL "$filef;";
}
}
close (FILEL);

$filedele="$DATAPATH/$FORM{'tophide'}.txt";

     unlink ($filedele) || &errorfile;

$filedeled="$DATAPATH/$FORM{'tophide'}.dat";

     unlink ($filedeled) || &errorfile;

$filehide="$FORM{'tophide'} and it's files have been deleted.";
&headerhide;
exit;

}

if ($FORM{'hideit'} eq "UNHIDE") {


     open (FILEY, "<$LISTPATH/slist.txt") || &errorfile;
@filey = split(';', <FILEY>);
close (FILEY);

foreach $filey (@filey) {

if ($filey eq $FORM{'topunhide'}) {
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><font face=\"verdana\" size=\"3\" color=\"#000000\"><b>$FORM{'topunhide'} has already been unhidden or deleted.</b></font>\n";
     &getprefhead;
     print "</center></body></html>\n";
exit;
}
}

     open (FILER, "<$DATAPATH/$FORM{'topunhide'}.txt") || &errorfile;
@filer = split (';', <FILER>);
close (FILER);

$oldnumbers=$filer[1]+$filer[2]+$filer[3]+$filer[4]+$filer[5];

     open (FILESUM, "<$LISTPATH/stlist.txt") || &errorfile;
@filesum = <FILESUM>;
close (FILESUM);

$oldgrand=$filesum[0];
$newtotal=$oldgrand + $oldnumbers;

     open (FILESUM, ">$LISTPATH/stlist.txt") || &errorfile;

print FILESUM "$newtotal";

close (FILESUM);

     open (FILEH, "<$LISTPATH/shlist.txt") || &errorfile;
@fileh = split(';', <FILEH>);
close (FILEH);

     open (FILEH, ">$LISTPATH/shlist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILEH, 2;
}

foreach $fileh (@fileh) {
     if ($fileh ne $FORM{'topunhide'}) {
     print FILEH "$fileh;";
}
}
close (FILEH);

     open (FILEL, ">>$LISTPATH/slist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock FILEL, 2;
}
     print FILEL "$FORM{'topunhide'};";
close (FILEL);

$filehide="$FORM{'topunhide'} has been unhidden.";
&headerhide;
exit;
}

exit;
}


##########getpreferror

sub getpreferror {

if ($FORM{'validref'} eq "yes") {
     $sel1="SELECTED";
}
else {
     $sel11="SELECTED";
}
if ($FORM{'checkip'} eq "yes") {
     $sel2="SELECTED";
}
else {
     $sel22="SELECTED";
}
if ($FLOCKIT eq "yes") {
     $selec100a="SELECTED";
}
else {
     $selec100b="SELECTED";
}

     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b><br>There is a problem with one or more fields. - Preference Page 1\n";
     print "<br><br><br></b></font>\n";
print "<table width=\"100%\"><td>\n";
print "<form action=\"$script_url?getprefp1b\" method=\"POST\">\n";
print "<font face=\"verdana\" size=\"2\" color=\"#000000\">\n";
print "URL of stars.pl script$rederror2<br>ex. - http://yourdomain.com/stars/stars.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl\" value=\"$FORM{'scripturl'}\"><br><br>\n";
print "URL of stars2.pl script$rederror3<br>ex. - http://yourdomain.com/stars/stars2.pl<br>\n";
print "<input type=\"text\" size=\"45\" name=\"scripturl2\" value=\"$FORM{'scripturl2'}\"><br><br>\n";
print "URL Path to star images - <font color=\"blue\">no trailing slash</font>.$rederror4<br><br>ex. - http://yourdomain.com/stars/starimages<br>\n";
print "<input type=\"text\" size=\"45\" name=\"imgpath\" value=\"$FORM{'imgpath'}\"><br><br>\n";
print "Root path to sdata folder - <font color=\"blue\">no trailing slash</font>.<br>ex. - /home/web/sites423a/stars/sdata<br>\n";
print "NOTE: This folder contains the data files for each topic.<br>\n";
print "The actual files are created on Preference Page 2.$rederror5<br>\n";
print "<input type=\"text\" size=\"45\" name=\"datapath\" value=\"$FORM{'datapath'}\"><br><br>\n";
print "Root path to slist, shlist, and stlist .txt files - <font color=\"blue\">no trailing slash</font>.$rederror6<br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"listpath\" value=\"$FORM{'listpath'}\"><br><br>\n";
print "Root path to Header and Footer text files - <font color=\"blue\">no trailing slash</font>.$rederror7<br>ex. - /home/web/sites423a/stars<br>\n";
print "<input type=\"text\" size=\"45\" name=\"headpath\" value=\"$FORM{'headpath'}\"><br><br>\n";
print "Valid Referer: \"Yes\" allows the stars.pl script to only be called from your domain. \n";
print "For security, yes is recommended.<br>\n";
print "<select name=\"validref\"><option name=\"validref\" value=\"yes\" $sel1>yes<option name=\"validref\" value=\"no\" $sel11>no</select><br><br>\n";
print "Valid Referer Domain: If yes to above,<br>\n";
print "this is the Domain name this script will be used on.<br>\n";
print "Don't forget the .com, .net, etc.$rederror8<br>ex. - yourdomain.com<br>\n";
print "<input type=\"text\" name=\"validreferer\" value=\"$FORM{'validreferer'}\"><br><br>\n";
print "Check IP: \"Yes\" means only one rating per user per topic.<br>\n";
print "<select name=\"checkip\"><option name=\"checkip\" value=\"yes\" $sel2>yes<option name=\"checkip\" value=\"no\" $sel22>no</select><br><br><br>\n";

print "File Locking: Will cause errors and possibly, permanently jumble data files if not supported by server. \n";
print "Default set to off. Turn on ONLY if you know you can or to test. Only test when all data files are backed up. *See README.Stars for more info.<br>\n";
print "<select name=\"flockit\"><option name=\"flockit\" value=\"yes\" $selec100a>on<option name=\"flockit\" value=\"no\" $selec100b>off</select><br><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp2\">\n";

print "<input type=\"submit\" value=\"SUBMIT CHANGES\"></form></b></font></td></table>\n";
     print "</td></table></center></body></html>\n";

exit;
}

########## sub headerhide

sub headerhide {

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>IMPORTANT: Do not back up from this page.\n";
     print "Making changes from the cached page can cause errors and may permantly jumble list text files. To make more changes to Pref Page 2, use the pop-up menu below.<br><br></b></font>\n";
     print "<center><font face=\"verdana\" size=\"3\" color=\"blue\"><b> $filehide<br><br></b></font>\n";
     print "</center>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a><br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a><br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";

&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";


exit;
}


##########getaver

sub getaver {

     print "<hr><font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 3 - Main Page and Rate Window variables</b></font><hr>\n";
     print "<p align=right><font face=\"verdana\" size=\"2\" color=\"#000000\">1 Topic shown for example</font></p>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"#000000\">NOTE: Any link colors displayed are browser defaults.<br>Actual links colors specified in header text files.<br><br>\n";
     print "<font face=\"verdana\" size=\"3\" color=\"blue\">IMPORTANT: No semicolons or quotation marks in any of the fields below.<br><br><br></font>\n";

if ($HEADYES eq "yes") {

     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\">\n";
     print "<td align=\"$HEADAL\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORH\"><b>$HEADTITLE</b></font></td></table>$TABLA2\n";
     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\" border=\"$BORDER\">\n";

}
else {

     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\" border=\"$BORDER\">\n";

}

if ($ASKDISHEAD eq "yes") {

     print "<tr>\n";

if ($ASKSTARS eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLESTARS</b></font></td>\n";
}

if ($ASKAVERAGE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLEAVERAGE</b></font></td>\n";
}

if ($ASKTOTAL eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLETOTAL</b></font></td>\n";
}

if ($ASKTITLE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLETITLE</b></font></td>\n";
}

if ($ASKDESCRIP eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\" $NOWRAP3><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLEDESCRIP</b></font></td>\n";
}

if ($ASKRATE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLERATE</b></font></td>\n";
}
print "</tr>\n";
}


     open (FILE, "<$LISTPATH/slist.txt") || &errorfile;
@file = split (';', <FILE>);
close (FILE);

if ($SORTORDER eq "recenttop") {
@file = reverse (@file);
}
if ($SORTORDER eq "alpha") {
@file = sort (@file);
}


for $topic ($file[0]) {

print "<tr>\n";

     open (DATA, "<$DATAPATH/$topic.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

$totalvotes=$sdata[1]+$sdata[2]+$sdata[3]+$sdata[4]+$sdata[5];

if (($totalvotes eq "0") && ($ASKSTARS eq "no")) {
     print "\n";
}

elsif (($totalvotes eq "0") && ($ASKSTARS eq "yes")) {
     print "<td align=\"$CELL1\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<img src=\"$IMGPATH/nostars.$GIFO\" border=\"0\"></td>\n";
}

elsif ($totalvotes > 0) {
$totalpoints=$sdata[1]*1+$sdata[2]*2+$sdata[3]*3+$sdata[4]*4+$sdata[5]*5;
$average=$totalpoints / $totalvotes;
$averager= sprintf("%.1f", $average);


if (($averager >= 1) && ($averager < 1.3)) {
    $starvalue="one";
}

elsif (($averager >= 1.3) && ($averager < 1.8)) {
    $starvalue="oneh";
}

elsif (($averager >= 1.8) && ($averager < 2.3)) {
    $starvalue="two";
}

elsif (($averager >= 2.3) && ($averager < 2.8)) {
    $starvalue="twoh";
}

elsif (($averager >= 2.8) && ($averager < 3.3)) {
    $starvalue="three";
}

elsif (($averager >= 3.3) && ($averager < 3.8)) {
    $starvalue="threeh";
}

elsif (($averager >= 3.8) && ($averager < 4.3)) {
    $starvalue="four";
}

elsif (($averager >= 4.3) && ($averager < 4.8)) {
    $starvalue="fourh";
}

elsif ($averager >= 4.8) {
    $starvalue="five";
}
}

if (($ASKSTARS eq "yes") && ($totalvotes > 0)) {

     print "<td align=\"$CELL1\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<img src=\"$IMGPATH/$starvalue.$GIFO\" border=\"0\"></td>\n";
}

if (($ASKAVERAGE eq "yes") && ($totalvotes > 0)) {
     print "<td align=\"$CELL2\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$averager</font></td>\n";
}
elsif (($ASKAVERAGE eq "yes") && ($totalvotes eq "0")) {
     print "<td align=\"$CELL2\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">0</font></td>\n";
}
elsif ($ASKAVERAGE eq "no") {
     print "\n";
}

if ($ASKTOTAL eq "yes") {
     print "<td align=\"$CELL3\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$totalvotes</font></td>\n";
}

     if (($ASKTITLE eq "yes") && ($LINKTITLE eq "no")) {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>$sdata[0]</b></font></td>\n";
 }
else {

if (($ASKTITLE eq "yes") && ($ASKSTAY eq "yes")) {

     if ($ASKSTAYW eq "no") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "<a href=\"$SCRIPTURL2?$topic\" onClick=\"newWindow = openWin( '$SCRIPTURL2?$topic', 'target98', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a></b></font></td>\n";
 }
     if ($ASKSTAYW eq "yes") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b><a href=\"$SCRIPTURL2?$topic\">$sdata[0]</a></b></font></td>\n";
 }
     
}

elsif (($ASKTITLE eq "yes") && ($ASKSTAY eq "no")) {

     if ($ASKSTAYW eq "no") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "<a href=\"$sdata[7]\" onClick=\"newWindow = openWin( '$sdata[7]', 'target97', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a></td>\n";
}
     if ($ASKSTAYW eq "yes") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b><a href=\"$sdata[7]\">$sdata[0]</a></b></font></td>\n";
 }
}
elsif ($ASKTITLE eq "no") {
     print "\n";
 }
}

if ($sdata[9] eq "") {
$sdatanine="&nbsp;&nbsp;";
}
else {
$sdatanine=$sdata[9];
}

if ($ASKDESCRIP eq "yes") {
     print "<td align=\"$CELL5\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP2>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$sdatanine</font></td>\n";
}

if (($ASKRATE eq "yes") && ($ASKWINDOW eq "yes")) {
     print "<td align=\"$CELL6\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$topic\" onClick=\"newWindow = openWin( '$SCRIPTURL?$topic', 'target99', 'width=$LWWIDTH,height=$LWHEIGHT,toolbar=0,location=0,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif (($ASKRATE eq "yes") && ($ASKWINDOW eq "no")) {
     print "<td align=\"$CELL6\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$topic\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif ($ASKRATE eq "no") {
     print "\n";
}

     print "</tr>\n";
    }

     print "</table>$TABLA2\n";


if ($WANTTOTAL eq "yes") {

     open (VFILE, "<$LISTPATH/stlist.txt") || &errorfile;
@vfile = <VFILE>;
close (VFILE);

     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\">\n";
     print "<td align=\"$FOOTAL\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORV1\"><b>$VOTETEXT$vfile[0]</b></font></td></table>$TABLA2\n";

   }

}

##########getprefp3

sub getprefp3 {
     print "Content-type:text/html\n\n";
     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\">\n";
print "<script language=\"JavaScript\">\n";
print "<!--\n";
print "        function openWin( windowURL, windowName, windowFeatures ) { \n";
print "                return window.open( windowURL, windowName, windowFeatures ) ; \n";
print "        } \n";
print "// -->\n";
print "</script>\n";
     print "</head><body bgcolor=\"$DISCOLOR\">\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a> (Will open in a new window)<br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a> (Will open in a new window)<br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";

&getprefhead;

     print "<br><br><center><font size=\"3\" color=\"blue\">You must click \"SAVE CHANGES\" at bottom for changes to take effect.</font></center><br><br></b></font>\n";

&getaver;

if ($ASKDISHEAD eq "yes") {
     $so13a="SELECTED";
}
else {
     $so13b="SELECTED";
}
if ($HCELL1 eq "left") {
     $so14a="SELECTED";
}
if ($HCELL1 eq "center") {
     $so14b="SELECTED";
}
if ($HCELL1 eq "right") {
     $so14c="SELECTED";
}
if ($HEADYES eq "yes") {
     $so15a="SELECTED";
}
else {
     $so15b="SELECTED";
}
if ($HEADAL eq "left") {
     $so16a="SELECTED";
}
if ($HEADAL eq "center") {
     $so16b="SELECTED";
}
if ($HEADAL eq "right") {
     $so16c="SELECTED";
}
if ($WANTTOTAL eq "yes") {
     $so17a="SELECTED";
}
else {
     $so17b="SELECTED";
}
if ($FOOTAL eq "left") {
     $so18a="SELECTED";
}
if ($FOOTAL eq "center") {
     $so18b="SELECTED";
}
if ($FOOTAL eq "right") {
     $so18c="SELECTED";
}
if ($TABLA1 eq "<left>") {
     $so19a="SELECTED";
}
else {
     $so19b="SELECTED";
}
if ($CELL1 eq "left") {
     $so20a="SELECTED";
}
if ($CELL1 eq "center") {
     $so20b="SELECTED";
}
if ($CELL1 eq "right") {
     $so20c="SELECTED";
}
if ($CELL2 eq "left") {
     $so21a="SELECTED";
}
if ($CELL2 eq "center") {
     $so21b="SELECTED";
}
if ($CELL2 eq "right") {
     $so21c="SELECTED";
}
if ($CELL3 eq "left") {
     $so22a="SELECTED";
}
if ($CELL3 eq "center") {
     $so22b="SELECTED";
}
if ($CELL3 eq "right") {
     $so22c="SELECTED";
}
if ($CELL4 eq "left") {
     $so23a="SELECTED";
}
if ($CELL4 eq "center") {
     $so23b="SELECTED";
}
if ($CELL4 eq "right") {
     $so23c="SELECTED";
}
if ($CELL5 eq "left") {
     $so24a="SELECTED";
}
if ($CELL5 eq "center") {
     $so24b="SELECTED";
}
if ($CELL5 eq "right") {
     $so24c="SELECTED";
}
if ($CELL6 eq "left") {
     $so25a="SELECTED";
}
if ($CELL6 eq "center") {
     $so25b="SELECTED";
}
if ($CELL6 eq "right") {
     $so25c="SELECTED";
}
if ($NOWRAP eq "wrap") {
     $so26a="SELECTED";
}
else {
     $so26b="SELECTED";
}
if ($NOWRAP2 eq "wrap") {
     $so27a="SELECTED";
}
else {
     $so27b="SELECTED";
}
if ($NOWRAP3 eq "wrap") {
     $so28a="SELECTED";
}
else {
     $so28b="SELECTED";
}
if ($VCELL1 eq "top") {
     $so29a="SELECTED";
}
if ($VCELL1 eq "middle") {
     $so29b="SELECTED";
}
if ($VCELL1 eq "bottom") {
     $so29c="SELECTED";
}

if ($SORTORDER eq "recenttop") {
     $so1a="SELECTED";
}
if ($SORTORDER eq "recentbottom") {
     $so1b="SELECTED";
}
if ($SORTORDER eq "alpha") {
     $so1c="SELECTED";
}

if ($GIFO eq "gif") {
     $so2a="SELECTED";
}
else {
     $so2b="SELECTED";
}

if ($ASKSTARS eq "yes") {
     $so3a="SELECTED";
}
else {
     $so3b="SELECTED";
}
if ($ASKAVERAGE eq "yes") {
     $so4a="SELECTED";
}
else {
     $so4b="SELECTED";
}
if ($ASKTOTAL eq "yes") {
     $so5a="SELECTED";
}
else {
     $so5b="SELECTED";
}
if ($ASKTITLE eq "yes") {
     $so6a="SELECTED";
}
else {
     $so6b="SELECTED";
}
if ($ASKDESCRIP eq "yes") {
     $so7a="SELECTED";
}
else {
     $so7b="SELECTED";
}
if ($ASKRATE eq "yes") {
     $so8a="SELECTED";
}
else {
     $so8b="SELECTED";
}
if ($ASKSTAY eq "yes") {
     $so9a="SELECTED";
}
else {
     $so9b="SELECTED";
}
if ($ASKSTAYW eq "no") {
     $so10a="SELECTED";
}
else {
     $so10b="SELECTED";
}
if ($ASKWINDOW eq "yes") {
     $so11a="SELECTED";
}
else {
     $so11b="SELECTED";
}

if ($LINKTITLE eq "yes") {
     $so99a="SELECTED";
}
else {
     $so99b="SELECTED";
}

     print "<table width=\"100%\" cellpadding=\"15\" cellspacing=\"0\" border=\"0\"><tr><td><font face=\"verdana\" size=\"2\"><b>Page Description \& Totaler</b></font></td>\n";
     print "<td><font face=\"verdana\" size=\"2\"><b>Columns \& Titles</b></font></td> <td><font face=\"verdana\" size=\"2\"><b>Table \& Cells</b></font></td></tr><tr>\n";
     print "<form action=\"$script_url?getprefp3b\" method=\"POST\"><td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">Would you like the Page Description displayed?<br>\n";
     print "<select name=\"headyes\"><option name=\"headyes\" value=\"yes\" $so15a>yes\n";
     print "<option name=\"headyes\" value=\"no\" $so15b>no</select><br><br>\n";
     print "What do you want it to say?<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br>\n";
     print "<input type=\"text\" name=\"headtitle\" value=\"$HEADTITLE\" size=\"15\"><br><br>\n";
     print "Page Description Font Color - include # sign if using hex\n";
     print "<input type=\"text\" name=\"fontcolorh\" value=\"$FONTCOLORH\" size=\"7\"><br><br>\n";
     print "How do you want it aligned?<br>NOTE: If this variable doesn't appear to be working, check Table variables at right.<br>\n";
     print "&nbsp;<select name=\"headal\"><option name=\"headal\" value=\"left\" $so16a>left\n";
     print "<option name=\"headal\" value=\"center\" $so16b>center\n";
     print "<option name=\"headal\" value=\"right\" $so16c>right</select><br><br>\n";
     print "Would you like the total number of ratings for ALL Topics displayed?<br>\n";
     print "<select name=\"wanttotal\"><option name=\"wanttotal\" value=\"yes\" $so17a>yes\n";
     print "<option name=\"wanttotal\" value=\"no\" $so17b>no</select><br><br>\n";
     print "What do you want it to say?<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br>\n";
     print "<input type=\"text\" name=\"votetext\" value=\"$VOTETEXT\" size=\"15\"><br><br>\n";
     print "Grand Rating Total Font Color - include # sign if using hex\n";
     print "<input type=\"text\" name=\"fontcolorv1\" value=\"$FONTCOLORV1\" size=\"7\"><br><br>\n";
     print "How do you want it aligned?<br>NOTE: If this variable doesn't appear to be working, check Table variables at top right.<br>\n";
     print "&nbsp;<select name=\"footal\"><option name=\"footal\" value=\"left\" $so18a>left\n";
     print "<option name=\"footal\" value=\"center\" $so18b>center\n";
     print "<option name=\"footal\" value=\"right\" $so18c>right</select></td>\n";


     print "<td valign=\"top\" width=\"34%\"><font face=\"verdana\" size=\"2\">Would you like the following columns displayed?<br>\n";
     print "<table>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Stars: </b></font></td><td><select name=\"askstars\"><option name=\"askstars\" value=\"yes\" $so3a>yes\n";
     print "<option name=\"askstars\" value=\"no\" $so3b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Average: </b></font></td><td><select name=\"askaverage\"><option name=\"askaverage\" value=\"yes\" $so4a>yes\n";
     print "<option name=\"askaverage\" value=\"no\" $so4b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Total: </b></font></td><td><select name=\"asktotal\"><option name=\"asktotal\" value=\"yes\" $so5a>yes\n";
     print "<option name=\"asktotal\" value=\"no\" $so5b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Title: </b></font></td><td><select name=\"asktitle\"><option name=\"asktitle\" value=\"yes\" $so6a>yes\n";
     print "<option name=\"asktitle\" value=\"no\" $so6b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Description: </b></font></td><td><select name=\"askdescrip\"><option name=\"askdescrip\" value=\"yes\" $so7a>yes\n";
     print "<option name=\"askdescrip\" value=\"no\" $so7b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Rate: </b></font></td><td><select name=\"askrate\"><option name=\"askrate\" value=\"yes\" $so8a>yes\n";
     print "<option name=\"askrate\" value=\"no\" $so8b>no</select></td></tr></table><br>\n";
     print "<font face=\"verdana\" size=\"2\">Would you like the column names displayed?<br>\n";
     print "&nbsp;<select name=\"askdishead\"><option name=\"askdishead\" value=\"yes\" $so13a>yes\n";
     print "<option name=\"askdishead\" value=\"no\" $so13b>no</select><br><br>\n";
     print "If yes:<br><br>\n";
     print "Align the column names...<br>\n";
     print "&nbsp;<select name=\"hcell1\"><option name=\"hcell1\" value=\"left\" $so14a>left\n";
     print "<option name=\"hcell1\" value=\"center\" $so14b>center\n";
     print "<option name=\"hcell1\" value=\"right\" $so14c>right</select><br>\n";
     print "Column Name Cell Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"color11\" value=\"$COLOR11\" size=\"7\"><br>\n";
     print "Column Name Font Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"fontcolort\" value=\"$FONTCOLORT\" size=\"7\"><br>\n";
     print "<br><font color=\"blue\">Note: No quotation marks or semicolons.</font><br><br>\n";
     print "Star column name<br>\n";
     print "<input type=\"text\" name=\"titlestars\" value=\"$TITLESTARS\" size=\"15\"><br>\n";
     print "Average column name<br>\n";
     print "<input type=\"text\" name=\"titleaverage\" value=\"$TITLEAVERAGE\" size=\"15\"><br>\n";
     print "Topic Total column name<br>\n";
     print "<input type=\"text\" name=\"titletotal\" value=\"$TITLETOTAL\" size=\"15\"><br>\n";
     print "Topic Title column name<br>\n";
     print "<input type=\"text\" name=\"titletitle\" value=\"$TITLETITLE\" size=\"15\"><br>\n";
     print "Description column name<br>\n";
     print "<input type=\"text\" name=\"titledescrip\" value=\"$TITLEDESCRIP\" size=\"15\"><br>\n";
     print "Rate It column name<br>\n";
     print "<input type=\"text\" name=\"titlerate\" value=\"$TITLERATE\" size=\"15\"><br></td>\n";

     print "<td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">NOTE: The width and align variables below, control the Page Title \& Totaler tables as well as the main table. \n";
     print "This will most likely only be noticeable if the width variable is set smaller than main table actually is. \n";
     print "Used creatively, the Title \& Totaler can appear indented.<br><br>\n";
     print "Table Font Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"fontcolor1\" value=\"$FONTCOLOR1\" size=\"7\"><br><br>\n";
     print "Table align:<br>\n";
     print "&nbsp;<select name=\"tabla1\"><option name=\"tabla1\" value=\"left\" $so19a>left\n";
     print "<option name=\"tabla1\" value=\"center\" $so19b>center</select><br><br>\n";
     print "Table Width - include % sign or no % sign means pixels<br>\n";
     print "<input type=\"text\" name=\"tabwidth\" value=\"$TABWIDTH\" size=\"4\"><br><br>\n";
     print "Table Height - include % sign or no % sign means pixels<br>NOTE: does some strange things, not consistent cross-browser, but still here for added table control.<br>\n";
     print "<input type=\"text\" name=\"tabheight\" value=\"$TABHEIGHT\" size=\"4\"><br><br>\n";
     print "Cellpadding: <input type=\"text\" name=\"cellpadding\" value=\"$CELLPADDING\" size=\"2\"><br><br>\n";
     print "Cellspacing: <input type=\"text\" name=\"cellspacing\" value=\"$CELLSPACING\" size=\"2\"><br><br>\n";
     print "Border: <input type=\"text\" name=\"border\" value=\"$BORDER\" size=\"2\"><br><br>\n";
     print "Cells Background Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"color1\" value=\"$COLOR1\" size=\"7\"><br><br>\n";
     print "Text cells Vertical align:<br>\n";
     print "&nbsp;<select name=\"vcell1\"><option name=\"vcell1\" value=\"top\" $so29a>top\n";
     print "<option name=\"vcell1\" value=\"middle\" $so29b>middle\n";
     print "<option name=\"vcell1\" value=\"bottom\" $so29c>bottom</select><br><br>\n";
     print "Text Cell Align:<br><br>Stars cell align:<br>\n";
     print "&nbsp;<select name=\"cell1\"><option name=\"cell1\" value=\"left\" $so20a>left\n";
     print "<option name=\"cell1\" value=\"center\" $so20b>center\n";
     print "<option name=\"cell1\" value=\"right\" $so20c>right</select><br>\n";
     print "Average cell align:<br>\n";
     print "&nbsp;<select name=\"cell2\"><option name=\"cell2\" value=\"left\" $so21a>left\n";
     print "<option name=\"cell2\" value=\"center\" $so21b>center\n";
     print "<option name=\"cell2\" value=\"right\" $so21c>right</select><br>\n";
     print "Topic Total cell align:<br>\n";
     print "&nbsp;<select name=\"cell3\"><option name=\"cell3\" value=\"left\" $so22a>left\n";
     print "<option name=\"cell3\" value=\"center\" $so22b>center\n";
     print "<option name=\"cell3\" value=\"right\" $so22c>right</select><br>\n";
     print "Topic Title cell align:<br>\n";
     print "&nbsp;<select name=\"cell4\"><option name=\"cell4\" value=\"left\" $so23a>left\n";
     print "<option name=\"cell4\" value=\"center\" $so23b>center\n";
     print "<option name=\"cell4\" value=\"right\" $so23c>right</select><br>\n";
     print "Description cell align:<br>\n";
     print "&nbsp;<select name=\"cell5\"><option name=\"cell5\" value=\"left\" $so24a>left\n";
     print "<option name=\"cell5\" value=\"center\" $so24b>center\n";
     print "<option name=\"cell5\" value=\"right\" $so24c>right</select><br>\n";
     print "Rate It cell align:<br>\n";
     print "&nbsp;<select name=\"cell6\"><option name=\"cell6\" value=\"left\" $so25a>left\n";
     print "<option name=\"cell6\" value=\"center\" $so25b>center\n";
     print "<option name=\"cell6\" value=\"right\" $so25c>right</select><br><br>\n";
     print "NOWRAP options:<br><br>\n";
     print "Title cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap\"><option name=\"nowrap\" value=\"wrap\" $so26a>wrap ok\n";
     print "<option name=\"nowrap\" value=\"nowrap\" $so26b>nowrap</select><br>\n";
     print "Description cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap2\"><option name=\"nowrap2\" value=\"wrap\" $so27a>wrap ok\n";
     print "<option name=\"nowrap2\" value=\"nowrap\" $so27b>nowrap</select><br>\n";
     print "Description Title cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap3\"><option name=\"nowrap3\" value=\"wrap\" $so28a>wrap ok\n";
     print "<option name=\"nowrap3\" value=\"nowrap\" $so28b>nowrap</select></td></tr></table>\n";


&getaver;

     print "<table width=\"100%\" cellpadding=\"15\" cellspacing=\"0\" border=\"0\"><tr><td><font face=\"verdana\" size=\"2\"><b>General</b></font></td>\n";
     print "<td><font face=\"verdana\" size=\"2\"><b>Define Rate Window \& Link Back Text</b></font></td><td><font face=\"verdana\" size=\"2\"><b>Define Single Topic Window</b></font></td></tr>\n";
     print "<tr><td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">\n";
     print "Background Color of the page you're on (for future viewing).<br>- include # sign if using hex<br><input type=\"text\" name=\"discolor\" value=\"$DISCOLOR\" size=\"7\"><br><br>\n";
     print "Font:<br>\n";
     print "<font color=\"blue\">Note: You can separate secondary fonts by commas.</font><br>\n";
     print "<input type=\"text\" name=\"fontface\" value=\"$FONTFACE\" size=\"8\"><br><br>\n";
     print "Fontsize Big:<br>\n";
     print "<font color=\"blue\">Page Titles.</font><br>\n";
     print "<input type=\"text\" name=\"fontsizebig\" value=\"$FONTSIZEBIG\" size=\"1\"><br><br>\n";
     print "Fontsize Medium:<br>\n";
     print "<font color=\"blue\">Table Cell Titles.</font><br>\n";
     print "<input type=\"text\" name=\"fontsizemed\" value=\"$FONTSIZEMED\" size=\"1\"><br><br>\n";
     print "Fontsize Small:<br>\n";
     print "<font color=\"blue\">Table Cell Text \& Grand Total Numbers.</font><br>\n";
     print "<input type=\"text\" name=\"fontsizesm\" value=\"$FONTSIZESM\" size=\"1\"><br><br>\n";
     print "Sort List Order:<br>NOTE: To further manipulate sort order, you can also HIDE and UNHIDE on Pref Page 2.<br>\n";
     print "Alpha-Num is based on One Word Name you chose when you created Topic, not the Topic Title that is displayed.<br><select name=\"sortorder\"><option name=\"sortorder\" value=\"recenttop\" $so1a>Recent Top\n";
     print "<option name=\"sortorder\" value=\"recentbottom\" $so1b>Recent Bottom\n";
     print "<option name=\"sortorder\" value=\"alpha\" $so1c>Alpha-Num</select><br><br>\n";
     print "gif or jpg:<br>NOTE: Unless you've changed the graphics that came with this script, this should be set to \"gif\".<br><select name=\"gifo\"><option name=\"gifo\" value=\"gif\" $so2a>gif\n";
     print "<option name=\"gifo\" value=\"jpg\" $so2b>jpg</select></td>\n";

     print "<td width=\"34%\" valign=\"top\"><font face=\"verdana\" size=\"2\">\n";
     print "Do you want Rate Button to open a remote window?<br>NOTE: JavaScript causes errors in older versions of Internet Explorer.<br><select name=\"askwindow\"><option name=\"askwindow\" value=\"yes\" $so11a>yes\n";
     print "<option name=\"askwindow\" value=\"no\" $so11b>no</select><br><br>\n";
     print "If applicable, define window (in pixels):<br></font>\n";
     print "<table><tr><td><font face=\"verdana\" size=\"2\">&nbsp;Width: </font></td><td><input type=\"text\" name=\"lwwidth\" value=\"$LWWIDTH\" size=\"3\"></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">&nbsp;Height: </font></td><td><input type=\"text\" name=\"lwheight\" value=\"$LWHEIGHT\" size=\"3\"></td></tr></table>\n";
     print "<font face=\"verdana\" size=\"2\">Font Color - include # sign if using hex<br><input type=\"text\" name=\"fontcolorw\" value=\"$FONTCOLORW\" size=\"7\"><br><br>\n";
     print "<font face=\"verdana\" size=\"2\">If Check IP \"yes\" (Page 1 Variables), Double Rating Text:<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br>\n";
     print "<input type=\"text\" name=\"doublevote\" value=\"$DOUBLEVOTE\" size=\"25\"><br><br>\n";
     print "<font face=\"verdana\" size=\"2\">Thanks Footer Text:<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br>\n";
     print "<input type=\"text\" name=\"rethankst\" value=\"$RETHANKST\" size=\"25\"><br><br><br>\n";

     print "<input type=\"hidden\" name=\"relink\" value=\"$RELINK\">\n";
     print "<font face=\"verdana\" size=\"2\"><b>Link Back Text</b><br><br>If at any time you answer no to remote windows,\n";
     print " links are automatically placed, where needed, just above your footer text.\n";
     print "Depending on your configuration, there may be a link to your Single Topic Pages (that link is named by the script and cannot be changed).\n";
     print "The other link will always link to your Main Page. Enter the text for that link here.<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font></font><br>\n";
     print "<input type=\"text\" name=\"relink2\" value=\"$RELINK2\" size=\"25\">\n";
     print "</td>\n";

     print "<td width=\"33%\" valign=\"top\"><font face=\"verdana\" size=\"2\">\n";
     print "Will Topic Titles be links?<br><br>IMPORTANT:<br>1) Even if these links are only going to the Single Topic Pages of this script, you must answer \"yes\".<br>\n";
     print "2) If you answer \"no\",  the Single Topic Pages of this script will not be used and the Topic Titles will appear as plain text. (So you needn't set any variables on Pref Page 4)<br>\n";
     print "<select name=\"linktitle\"><option name=\"linktitle\" value=\"yes\" $so99a>yes\n";
     print "<option name=\"linktitle\" value=\"no\" $so99b>no</select><br><br>\n";

     print "If \"yes\" to above, will Topic Titles link to Page 2 of this script (Single Topic Pages) or go to other URLs?<br><br>\n";
     print "IMPORTANT: If you select \"go to other URLs\":<br>1) ALL Topic Titles on the Main Page will be set to link to the URLs specified on the Edit/Create/Hide Topics Page (Pref Page 2). EVERY Topic will need a URL assigned to it.<br>\n";
     print "2) The Single Topic Pages of this script will not be used. (So you needn't set any variables on Pref Page 4)<br><br>\n";
     print "NOTE: By selecting the default, \"Page 2\", you can then use Pref Page 4 to set the Topic Titles on the Single Topic Pages to link to other URLs. (Further explanation of this on Pref Page 4)<br>\n";
     print "<select name=\"askstay\"><option name=\"askstay\" value=\"yes\" $so9a>Page 2\n";
     print "<option name=\"askstay\" value=\"no\" $so9b>go to other URLs</select><br><br>\n";
     print "Either way, do you want link to pop to a new window?<br>NOTE: JavaScript causes errors in older versions of Internet Explorer.<br><select name=\"askstayw\"><option name=\"askstayw\" value=\"no\" $so10a>yes\n";
     print "<option name=\"askstayw\" value=\"yes\" $so10b>no</select><br><br>\n";
     print "If applicable, define window (in pixels):<br></font>\n";
     print "<table><tr><td><font face=\"verdana\" size=\"2\">&nbsp;Width: </font></td><td><input type=\"text\" name=\"bwwidth\" value=\"$BWWIDTH\" size=\"3\"></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">&nbsp;Height: </font></td><td><input type=\"text\" name=\"bwheight\" value=\"$BWHEIGHT\" size=\"3\"></td></tr>\n";
     print "</table></td></tr>\n";

     print "<tr><td align=\"center\" colspan=\"3\"><br><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp3\">\n";

     print "<input type=\"submit\" value=\"SAVE CHANGES\"><br><br></td>\n";
     print "</form></tr></table><hr>\n";


&footedit;
}

##########getprefp3b


sub getprefp3b {

&parseform;

     print "Content-type:text/html\n\n";

     open (DATAFILE, "<$config_path") || &errorfile;
@dataline=<DATAFILE>;
foreach $datafi(@dataline) {
chomp ($datafi);
}
close (DATAFILE);

     open (DATAFILE, ">$config_path") || &errorfile;

if ($FLOCKIT eq "yes") {
flock DATAFILE, 2;
}

@datanum=('0' .. '11');
$varpre="@dataline";

foreach $vari (@datanum) {

print DATAFILE "$dataline[$vari]\n";
}

if ($FORM{'tabla1'} eq "center") {
     $tabla1="<center>";
     $tabla2="</center>";
}
if ($FORM{'tabla1'} eq "left") {
     $tabla1="<left>";
     $tabla2="</left>";
}

print DATAFILE "\$DISCOLOR=\"$FORM{'discolor'}\"\;\n";
print DATAFILE "\$FONTFACE=\"$FORM{'fontface'}\"\;\n";
print DATAFILE "\$FONTSIZEBIG=\"$FORM{'fontsizebig'}\"\;\n";
print DATAFILE "\$FONTSIZEMED=\"$FORM{'fontsizemed'}\"\;\n";
print DATAFILE "\$FONTSIZESM=\"$FORM{'fontsizesm'}\"\;\n";
print DATAFILE "\$SORTORDER=\"$FORM{'sortorder'}\"\;\n";
print DATAFILE "\$GIFO=\"$FORM{'gifo'}\"\;\n";
print DATAFILE "\$ASKSTAY=\"$FORM{'askstay'}\"\;\n";
print DATAFILE "\$ASKSTAYW=\"$FORM{'askstayw'}\"\;\n";
print DATAFILE "\$BWWIDTH=\"$FORM{'bwwidth'}\"\;\n";
print DATAFILE "\$BWHEIGHT=\"$FORM{'bwheight'}\"\;\n";
print DATAFILE "\$ASKWINDOW=\"$FORM{'askwindow'}\"\;\n";
print DATAFILE "\$LWWIDTH=\"$FORM{'lwwidth'}\"\;\n";
print DATAFILE "\$LWHEIGHT=\"$FORM{'lwheight'}\"\;\n";
print DATAFILE "\$FONTCOLORW=\"$FORM{'fontcolorw'}\"\;\n";
print DATAFILE "\$DOUBLEVOTE=\"$FORM{'doublevote'}\"\;\n";
print DATAFILE "\$RETHANKST=\"$FORM{'rethankst'}\"\;\n";
print DATAFILE "\$RELINK=\"$FORM{'relink'}\"\;\n";
print DATAFILE "\$RELINK2=\"$FORM{'relink2'}\"\;\n";
print DATAFILE "\$ASKSTARS=\"$FORM{'askstars'}\"\;\n";
print DATAFILE "\$ASKAVERAGE=\"$FORM{'askaverage'}\"\;\n";
print DATAFILE "\$ASKTOTAL=\"$FORM{'asktotal'}\"\;\n";
print DATAFILE "\$ASKTITLE=\"$FORM{'asktitle'}\"\;\n";
print DATAFILE "\$ASKDESCRIP=\"$FORM{'askdescrip'}\"\;\n";
print DATAFILE "\$ASKRATE=\"$FORM{'askrate'}\"\;\n";
print DATAFILE "\$ASKDISHEAD=\"$FORM{'askdishead'}\"\;\n";
print DATAFILE "\$HCELL1=\"$FORM{'hcell1'}\"\;\n";
print DATAFILE "\$COLOR11=\"$FORM{'color11'}\"\;\n";
print DATAFILE "\$FONTCOLORT=\"$FORM{'fontcolort'}\"\;\n";
print DATAFILE "\$TITLESTARS=\"$FORM{'titlestars'}\"\;\n";
print DATAFILE "\$TITLEAVERAGE=\"$FORM{'titleaverage'}\"\;\n";
print DATAFILE "\$TITLETOTAL=\"$FORM{'titletotal'}\"\;\n";
print DATAFILE "\$TITLETITLE=\"$FORM{'titletitle'}\"\;\n";
print DATAFILE "\$TITLEDESCRIP=\"$FORM{'titledescrip'}\"\;\n";
print DATAFILE "\$TITLERATE=\"$FORM{'titlerate'}\"\;\n";
print DATAFILE "\$HEADYES=\"$FORM{'headyes'}\"\;\n";
print DATAFILE "\$HEADTITLE=\"$FORM{'headtitle'}\"\;\n";
print DATAFILE "\$FONTCOLORH=\"$FORM{'fontcolorh'}\"\;\n";
print DATAFILE "\$HEADAL=\"$FORM{'headal'}\"\;\n";
print DATAFILE "\$WANTTOTAL=\"$FORM{'wanttotal'}\"\;\n";
print DATAFILE "\$VOTETEXT=\"$FORM{'votetext'}\"\;\n";
print DATAFILE "\$FONTCOLORV1=\"$FORM{'fontcolorv1'}\"\;\n";
print DATAFILE "\$FOOTAL=\"$FORM{'footal'}\"\;\n";
print DATAFILE "\$FONTCOLOR1=\"$FORM{'fontcolor1'}\"\;\n";
print DATAFILE "\$TABLA1=\"$tabla1\"\;\n";
print DATAFILE "\$TABLA2=\"$tabla2\"\;\n";
print DATAFILE "\$TABWIDTH=\"$FORM{'tabwidth'}\"\;\n";
print DATAFILE "\$TABHEIGHT=\"$FORM{'tabheight'}\"\;\n";
print DATAFILE "\$CELLPADDING=\"$FORM{'cellpadding'}\"\;\n";
print DATAFILE "\$CELLSPACING=\"$FORM{'cellspacing'}\"\;\n";
print DATAFILE "\$BORDER=\"$FORM{'border'}\"\;\n";
print DATAFILE "\$COLOR1=\"$FORM{'color1'}\"\;\n";
print DATAFILE "\$CELL1=\"$FORM{'cell1'}\"\;\n";
print DATAFILE "\$CELL2=\"$FORM{'cell2'}\"\;\n";
print DATAFILE "\$CELL3=\"$FORM{'cell3'}\"\;\n";
print DATAFILE "\$CELL4=\"$FORM{'cell4'}\"\;\n";
print DATAFILE "\$CELL5=\"$FORM{'cell5'}\"\;\n";
print DATAFILE "\$CELL6=\"$FORM{'cell6'}\"\;\n";
print DATAFILE "\$VCELL1=\"$FORM{'vcell1'}\"\;\n";
print DATAFILE "\$NOWRAP=\"$FORM{'nowrap'}\"\;\n";
print DATAFILE "\$NOWRAP2=\"$FORM{'nowrap2'}\"\;\n";
print DATAFILE "\$NOWRAP3=\"$FORM{'nowrap3'}\"\;\n";
print DATAFILE "\$LINKTITLE=\"$FORM{'linktitle'}\"\;\n";

@datanumb=('75' .. '119');
$varpreb="@dataline";

foreach $varib (@datanumb) {

print DATAFILE "$dataline[$varib]\n";
}
print DATAFILE "$dataline[120]";

if ($FLOCKIT eq "yes") {
flock DATAFILE, 8;
}

close (DATAFILE);

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>Preference Page 3 - Main Page and Rate Window variables have been UPDATED.<br><br></b></font>\n";
     print "<font face=\"verdana\" size=\"3\" color=\"#000000\"><b>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a><br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a><br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";

&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";


exit;
}
##########getaver2

sub getaver2 {


     print "<font face=\"verdana\" size=\"3\" color=\"blue\"><b>Preference Page 4 - Single Topic Page variables</b></font><hr>\n";

     print "<center><font face=\"verdana\" size=\"2\" color=\"#000099\"><br><b>NOTE: These variables are for the second pages of the script ONLY.\n";
     print " If you selected \"link to other URLs\" on Pref Page 3, these Single Topic pages will not be seen, and therefore no variables need to be set.<br><br>\n";
     print "Remember: These settings have no affect on your Main Page (the page that lists ALL topics).<br><br><hr></b></font></center>\n";

     print "<p align=right><font face=\"verdana\" size=\"2\" color=\"#000000\">First Topic in filelist.txt shown for example</font></p>\n";
     print "<font face=\"verdana\" size=\"2\" color=\"#000000\">NOTE: Any link colors displayed are browser defaults.<br>Actual links colors specified in header text files.<br><br>\n";
     print "<font face=\"verdana\" size=\"3\" color=\"blue\">IMPORTANT: No semicolons or quotation marks in any of the fields below.<br><br><br></font>\n";

     open (TDATA, "<$LISTPATH/slist.txt") || &errorfile;
@tdata = split (';', <TDATA>);
close (TDATA);

     open (DATA, "<$DATAPATH/$tdata[0].txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

if (($HEADTITLE2 eq "yes") && ($ASKSTAY2 eq "yes")) {

     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$HEADAL2\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORH2\"><b>$sdata[0]</b></font></td></table>$TABLALIGN4A\n";
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" height=\"$TABHEIGHT2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\" border=\"$BORDER2\">\n";
     
}

elsif (($HEADTITLE2 eq "yes") && ($ASKSTAY2 eq "no")) {

     if ($ASKSTAYW2 eq "no") {

     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$HEADAL2\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORH2\"><b>\n";
     print "<a href=\"$sdata[7]\" onClick=\"newWindow = openWin( '$sdata[7]', 'target97', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a>\n";
     print "</b></font></td></table>$TABLALIGN4A\n";
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" height=\"$TABHEIGHT2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\" border=\"$BORDER2\">\n";

}
     if ($ASKSTAYW2 eq "yes") {

     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$HEADAL2\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORH2\"><b><a href=\"$sdata[7]\">$sdata[0]</a></b></font></td></table>$TABLALIGN4A\n";
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" height=\"$TABHEIGHT2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\" border=\"$BORDER2\">\n";

 }
}
elsif ($HEADTITLE2 eq "no") {
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" height=\"$TABHEIGHT2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\" border=\"$BORDER2\">\n";
}

if ($ASKDISHEAD2 eq "yes") {

     print "<tr>\n";

if ($ASKSTARS2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLESTARS2</b></font></td>\n";
}

if ($ASKAVERAGE2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLEAVERAGE2</b></font></td>\n";
}

if ($ASKTOTAL2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLETOTAL2</b></font></td>\n";
}

if ($ASKTITLE2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLETITLE2</b></font></td>\n";
}

if ($ASKDESCRIP2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\" $NOWRAP6><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLEDESCRIP2</b></font></td>\n";
}

if ($ASKRATE2 eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$TCOLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT2\"><b>$TITLERATE2</b></font></td>\n";
}
print "</tr>\n";
}

print "<tr>\n";


$totalvotes=$sdata[1]+$sdata[2]+$sdata[3]+$sdata[4]+$sdata[5];

if (($totalvotes eq "0") && ($ASKSTARS2 eq "no")) {
     print "\n";
}

elsif (($totalvotes eq "0") && ($ASKSTARS2 eq "yes")) {
     print "<td align=\"$CELL11\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<img src=\"$IMGPATH/nostars.$GIFO\" border=\"0\"></td>\n";
}

elsif ($totalvotes > 0) {
$totalpoints=$sdata[1]*1+$sdata[2]*2+$sdata[3]*3+$sdata[4]*4+$sdata[5]*5;
$average=$totalpoints / $totalvotes;
$averager= sprintf("%.1f", $average);


if (($averager >= 1) && ($averager < 1.3)) {
    $starvalue="one";
}

elsif (($averager >= 1.3) && ($averager < 1.8)) {
    $starvalue="oneh";
}

elsif (($averager >= 1.8) && ($averager < 2.3)) {
    $starvalue="two";
}

elsif (($averager >= 2.3) && ($averager < 2.8)) {
    $starvalue="twoh";
}

elsif (($averager >= 2.8) && ($averager < 3.3)) {
    $starvalue="three";
}

elsif (($averager >= 3.3) && ($averager < 3.8)) {
    $starvalue="threeh";
}

elsif (($averager >= 3.8) && ($averager < 4.3)) {
    $starvalue="four";
}

elsif (($averager >= 4.3) && ($averager < 4.8)) {
    $starvalue="fourh";
}

elsif ($averager >= 4.8) {
    $starvalue="five";
}
}

if (($ASKSTARS2 eq "yes") && ($totalvotes > 0)) {

     print "<td align=\"$CELL11\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<img src=\"$IMGPATH/$starvalue.$GIFO\" border=\"0\"></td>\n";
}

if (($ASKAVERAGE2 eq "yes") && ($totalvotes > 0)) {
     print "<td align=\"$CELL22\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORP2\">$averager</font></td>\n";
}
elsif (($ASKAVERAGE2 eq "yes") && ($totalvotes eq "0")) {
     print "<td align=\"$CELL22\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORP2\">0</font></td>\n";
}
elsif ($ASKAVERAGE2 eq "no") {
     print "\n";
}

if ($ASKTOTAL2 eq "yes") {
     print "<td align=\"$CELL33\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORP2\">$totalvotes</font></td>\n";
}

if (($ASKTITLE2 eq "yes") && ($ASKSTAY2 eq "yes")) {

     print "<td align=\"$CELL44\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\" $NOWRAP4>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "$sdata[0]</b></font></td>\n";
     
}

elsif (($ASKTITLE2 eq "yes") && ($ASKSTAY2 eq "no")) {

     if ($ASKSTAYW2 eq "no") {
     print "<td align=\"$CELL44\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\" $NOWRAP4>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "<a href=\"$sdata[7]\" onClick=\"newWindow = openWin( '$sdata[7]', 'target97', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a></td>\n";
}
     if ($ASKSTAYW2 eq "yes") {
     print "<td align=\"$CELL44\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\" $NOWRAP4>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b><a href=\"$sdata[7]\">$sdata[0]</a></b></font></td>\n";
 }
}
elsif ($ASKTITLE2 eq "no") {
     print "\n";
}

if ($sdata[9] eq "") {
$sdatanine="&nbsp;&nbsp;";
}
else {
$sdatanine=$sdata[9];
}

if ($ASKDESCRIP2 eq "yes") {
     print "<td align=\"$CELL55\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\" $NOWRAP5>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORP2\">$sdatanine</font></td>\n";
}

if (($ASKRATE2 eq "yes") && ($ASKWINDOW eq "yes")) {
     print "<td align=\"$CELL66\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$tdata[0]\" onClick=\"newWindow = openWin( '$SCRIPTURL?$tdata[0]', 'target99', 'width=$LWWIDTH,height=$LWHEIGHT,toolbar=0,location=0,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif (($ASKRATE2 eq "yes") && ($ASKWINDOW eq "no")) {
     print "<td align=\"$CELL66\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$tdata[0]\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif ($ASKRATE2 eq "no") {
     print "\n";
}

     print "</tr>\n";


     print "</table>$TABLALIGN4A\n";

if (($ASKRATE2U eq "yes") && ($ASKWINDOW eq "no")) {
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$CELL66\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\"><br><a href=\"$SCRIPTURL?$tdata[0]\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td></table>$TABLALIGN4A\n";
   }

if (($ASKRATE2U eq "yes") && ($ASKWINDOW eq "yes")) {
     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$CELL66\" valign=\"$VCELL1\" bgcolor=\"$TCOLOR1\">\n";
     print "<br><a href=\"$SCRIPTURL?$tdata[0]\" onClick=\"newWindow = openWin( '$SCRIPTURL?$tdata[0]', 'target99', 'width=$LWWIDTH,height=$LWHEIGHT,toolbar=0,location=0,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td></table>$TABLALIGN4A\n";
   }

if ($WANTTOTAL2 eq "yes") {

     print "$TABLALIGN3A<table width=\"$TABWIDTH2\" cellpadding=\"$CELLPADDING2\" cellspacing=\"$CELLSPACING2\">\n";
     print "<td align=\"$FOOTAL2\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORV2\"><b>$VOTETEXT2$totalvotes</b></font></td></table>$TABLALIGN4A\n";

}

}

##########getprefp4

sub getprefp4 {

     print "Content-type:text/html\n\n";

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\">\n";
print "<script language=\"JavaScript\">\n";
print "<!--\n";
print "        function openWin( windowURL, windowName, windowFeatures ) { \n";
print "                return window.open( windowURL, windowName, windowFeatures ) ; \n";
print "        } \n";
print "// -->\n";
print "</script>\n";
     print "</head><body bgcolor=\"$DISCOLOR\">\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a> (Will open in a new window)<br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a> (Will open in a new window)<br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";

&getprefhead;

     print "<br><br><center><font size=\"3\" color=\"blue\">You must click \"SAVE CHANGES\" at bottom for changes to take effect.</font></center><br><br></b></font><hr>\n";

&getaver2;

if ($HEADTITLE2 eq "yes") {
     $so40a="SELECTED";
}
else {
     $so40b="SELECTED";
}
if ($HEADAL2 eq "left") {
     $so41a="SELECTED";
}
if ($HEADAL2 eq "center") {
     $so41b="SELECTED";
}
if ($HEADAL2 eq "right") {
     $so41c="SELECTED";
}
if ($WANTTOTAL2 eq "yes") {
     $so42a="SELECTED";
}
else {
     $so42b="SELECTED";
}
if ($FOOTAL2 eq "left") {
     $so43a="SELECTED";
}
if ($FOOTAL2 eq "center") {
     $so43b="SELECTED";
}
if ($FOOTAL2 eq "right") {
     $so43c="SELECTED";
}


     print "<table cellpadding=\"15\" border=\"0\"><tr><td><font face=\"verdana\" size=\"2\"><b>Page Title \& Totaler</b></font></td>\n";
     print "<td><font face=\"verdana\" size=\"2\"><b>Columns Displayed</b></font></td> <td><font face=\"verdana\" size=\"2\"><b>Link \& Remote Window</b></font></td></tr><tr>\n";
     print "<form action=\"$script_url?getprefp4b\" method=\"POST\">\n";
     print "<td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">Would you like the Page Title displayed?<br>\n";
     print "<select name=\"headtitle2\"><option name=\"headtitle2\" value=\"yes\" $so40a>yes\n";
     print "<option name=\"headtitle2\" value=\"no\" $so40b>no</select><br><br>\n";
     print "Page Title Font Color - include # sign if using hex\n";
     print "<input type=\"text\" name=\"fontcolorh2\" value=\"$FONTCOLORH2\" size=\"7\"><br><br>\n";
     print "How do you want it aligned?<br>NOTE: If this variable doesn't appear to be working, check Table variables below.<br>\n";
     print "&nbsp;<select name=\"headal2\"><option name=\"headal2\" value=\"left\" $so41a>left\n";
     print "<option name=\"headal2\" value=\"center\" $so41b>center\n";
     print "<option name=\"headal2\" value=\"right\" $so41c>right</select><br><br>\n";
     print "Would you like the total number of ratings for this Topic displayed underneath?<br>\n";
     print "<select name=\"wanttotal2\"><option name=\"wanttotal2\" value=\"yes\" $so42a>yes\n";
     print "<option name=\"wanttotal2\" value=\"no\" $so42b>no</select><br><br>\n";
     print "What do you want it to say?<br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br>\n";
     print "<input type=\"text\" name=\"votetext2\" value=\"$VOTETEXT2\" size=\"15\"><br><br>\n";
     print "Grand Rating Total Font Color - include # sign if using hex\n";
     print "<input type=\"text\" name=\"fontcolorv2\" value=\"$FONTCOLORV2\" size=\"7\"><br><br>\n";
     print "How do you want it aligned?<br>NOTE: If this variable doesn't appear to be working, check Table variables below.<br>\n";
     print "&nbsp;<select name=\"footal2\"><option name=\"footal2\" value=\"left\" $so43a>left\n";
     print "<option name=\"footal2\" value=\"center\" $so43b>center\n";
     print "<option name=\"footal2\" value=\"right\" $so43c>right</select></td>\n";

if ($ASKSTARS2 eq "yes") {
     $so90a="SELECTED";
}
else {
     $so90b="SELECTED";
}
if ($ASKAVERAGE2 eq "yes") {
     $so91a="SELECTED";
}
else {
     $so91b="SELECTED";
}
if ($ASKTOTAL2 eq "yes") {
     $so44a="SELECTED";
}
else {
     $so44b="SELECTED";
}
if ($ASKTITLE2 eq "yes") {
     $so45a="SELECTED";
}
else {
     $so45b="SELECTED";
}
if ($ASKDESCRIP2 eq "yes") {
     $so46a="SELECTED";
}
else {
     $so46b="SELECTED";
}
if ($ASKRATE2 eq "yes") {
     $so47a="SELECTED";
}
else {
     $so47b="SELECTED";
}
if ($ASKRATE2U eq "yes") {
     $so48a="SELECTED";
}
else {
     $so48b="SELECTED";
}

     print "<td valign=\"top\" width=\"34%\"><font face=\"verdana\" size=\"2\">Would you like the following columns displayed?<br>\n";
     print "<table>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Stars: </b></font></td><td><select name=\"askstars2\"><option name=\"askstars2\" value=\"yes\" $so90a>yes\n";
     print "<option name=\"askstars2\" value=\"no\" $so90b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Average: </b></font></td><td><select name=\"askaverage2\"><option name=\"askaverage2\" value=\"yes\" $so91a>yes\n";
     print "<option name=\"askaverage2\" value=\"no\" $so91b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Total: </b></font></td><td><select name=\"asktotal2\"><option name=\"asktotal2\" value=\"yes\" $so44a>yes\n";
     print "<option name=\"asktotal2\" value=\"no\" $so44b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Title: </b></font></td><td><select name=\"asktitle2\"><option name=\"asktitle2\" value=\"yes\" $so45a>yes\n";
     print "<option name=\"asktitle2\" value=\"no\" $so45b>no</select></td></tr>\n";
     print "<tr><td><font face=\"verdana\" size=\"2\">Description: </b></font></td><td><select name=\"askdescrip2\"><option name=\"askdescrip2\" value=\"yes\" $so46a>yes\n";
     print "<option name=\"askdescrip2\" value=\"no\" $so46b>no</select></td></tr>\n";

     print "<tr><td><font face=\"verdana\" size=\"2\">Rate: </b></font></td><td><select name=\"askrate2\"><option name=\"askrate2\" value=\"yes\" $so47a>yes\n";
     print "<option name=\"askrate2\" value=\"no\" $so47b>no</select></td></tr>\n";

     print "<tr><td><font face=\"verdana\" size=\"2\">Rate Underneath: </b></font></td><td><select name=\"askrate2u\"><option name=\"askrate2u\" value=\"yes\" $so48a>yes\n";
     print "<option name=\"askrate2u\" value=\"no\" $so48b>no</select></td></tr></table></td>\n";

if ($ASKSTAY2 eq "no") {
     $so49a="SELECTED";
}
else {
     $so49b="SELECTED";
}
if ($ASKSTAYW2 eq "no") {
     $so50a="SELECTED";
}
else {
     $so50b="SELECTED";
}


     print "<td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">\n";
     print "Do you want Titles to be links? (This is just for the Single Topic Pages.)<br><br>\n";
     print "IMPORTANT: If you select \"yes\":<br>1) ALL Titles on the Single Topic Pages will be set to link to the URLs specified on the Edit/Create/Hide Topics Page \n";
     print "(Pref Page 2). EVERY Topic will need a URL assigned to it.<br>\n";
     print "NOTE: If you select \"no\", all Titles will appear as plain text (not a link).<br>\n";
     print "<select name=\"askstay2\"><option name=\"askstay2\" value=\"no\" $so49a>yes\n";
     print "<option name=\"askstay2\" value=\"yes\" $so49b>no</select><br><br>\n";

     print "If yes to above, would you like these links to pop to a remote window? (Height \& width of remote window can be defined on Pref Page 3)<br>\n";
     print "NOTE: JavaScript causes errors in older versions of Internet Explorer.<br><select name=\"askstayw2\"><option name=\"askstayw2\" value=\"no\" $so50a>yes\n";
     print "<option name=\"askstayw2\" value=\"yes\" $so50b>no</select><br><br>\n";

     print "<input type=\"hidden\" name=\"askwindow2\" value=\"yes\">\n";

     print "</td></tr></table><hr>\n";

&getaver2;

if ($ASKDISHEAD2 eq "yes") {
     $so60a="SELECTED";
}
else {
     $so60b="SELECTED";
}
     print "<table cellpadding=\"15\" border=\"0\"><tr><td><font face=\"verdana\" size=\"2\"><b>Columns \& Titles</b></font></td>\n";
     print "<td><font face=\"verdana\" size=\"2\"><b>Table variables \& Font</b></font></td> <td><font face=\"verdana\" size=\"2\"><b>Cell variables \& Page Text</b></font></td></tr><tr>\n";
     print "<td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">Would you like the column names displayed?<br>\n";
     print "&nbsp;<select name=\"askdishead2\"><option name=\"askdishead2\" value=\"yes\" $so60a>yes\n";
     print "<option name=\"askdishead2\" value=\"no\" $so60b>no</select><br><br>\n";
     print "If yes:<br><br>\n";
     print "Column Name Cell Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"tcolor11\" value=\"$TCOLOR11\" size=\"7\"><br>\n";
     print "Column Name Font Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"fontcolort2\" value=\"$FONTCOLORT2\" size=\"7\"><br><br>\n";
     print "<font color=\"blue\">Note: No quotation marks or semicolons.</font><br><br>\n";
     print "Star column name<br>\n";
     print "<input type=\"text\" name=\"titlestars2\" value=\"$TITLESTARS2\" size=\"15\"><br>\n";
     print "Average column name<br>\n";
     print "<input type=\"text\" name=\"titleaverage2\" value=\"$TITLEAVERAGE2\" size=\"15\"><br>\n";
     print "Topic Total column name<br>\n";
     print "<input type=\"text\" name=\"titletotal2\" value=\"$TITLETOTAL2\" size=\"15\"><br>\n";
     print "Topic Title column name<br>\n";
     print "<input type=\"text\" name=\"titletitle2\" value=\"$TITLETITLE2\" size=\"15\"><br>\n";
     print "Description column name<br>\n";
     print "<input type=\"text\" name=\"titledescrip2\" value=\"$TITLEDESCRIP2\" size=\"15\"><br>\n";
     print "Rate It column name<br>\n";
     print "<input type=\"text\" name=\"titlerate2\" value=\"$TITLERATE2\" size=\"15\"><br></td>\n";

if ($TABLALIGN3A eq "<left>") {
     $so61a="SELECTED";
}
else {
     $so61b="SELECTED";
}

     print "<td valign=\"top\" width=\"34%\"><font face=\"verdana\" size=\"2\">NOTE: The width and align variables below, control the Title \& Totaler tables as well as the main table. \n";
     print "This will most likely only be noticeable if the width variable is set smaller than main table actually is. \n";
     print "Used creatively, the Title \& Totaler can appear indented.<br><br>\n";
     print "Table Font Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"fontcolorp2\" value=\"$FONTCOLORP2\" size=\"7\"><br><br>\n";
     print "Table align:<br>\n";
     print "&nbsp;<select name=\"tablalign3a\"><option name=\"tablalign3a\" value=\"left\" $so61a>left\n";
     print "<option name=\"tablalign3a\" value=\"center\" $so61b>center</select><br><br>\n";
     print "Table Width - include % sign or no % sign means pixels<br>\n";
     print "<input type=\"text\" name=\"tabwidth2\" value=\"$TABWIDTH2\" size=\"4\"><br><br>\n";
     print "Table Height - include % sign or no % sign means pixels<br>NOTE: does some strange things, not consistent cross-browser, but still here for added table control.<br>\n";
     print "<input type=\"text\" name=\"tabheight2\" value=\"$TABHEIGHT2\" size=\"4\"><br><br>\n";
     print "Cellpadding: <input type=\"text\" name=\"cellpadding2\" value=\"$CELLPADDING2\" size=\"2\"><br><br>\n";
     print "Cellspacing: <input type=\"text\" name=\"cellspacing2\" value=\"$CELLSPACING2\" size=\"2\"><br><br>\n";
     print "Border: <input type=\"text\" name=\"border2\" value=\"$BORDER2\" size=\"2\"></td>\n";

if ($CELL11 eq "left") {
     $so62a="SELECTED";
}
if ($CELL11 eq "center") {
     $so62b="SELECTED";
}
if ($CELL11 eq "right") {
     $so62c="SELECTED";
}
if ($CELL22 eq "left") {
     $so63a="SELECTED";
}
if ($CELL22 eq "center") {
     $so63b="SELECTED";
}
if ($CELL22 eq "right") {
     $so63c="SELECTED";
}
if ($CELL33 eq "left") {
     $so64a="SELECTED";
}
if ($CELL33 eq "center") {
     $so64b="SELECTED";
}
if ($CELL33 eq "right") {
     $so64c="SELECTED";
}
if ($CELL44 eq "left") {
     $so65a="SELECTED";
}
if ($CELL44 eq "center") {
     $so65b="SELECTED";
}
if ($CELL44 eq "right") {
     $so65c="SELECTED";
}
if ($CELL55 eq "left") {
     $so66a="SELECTED";
}
if ($CELL55 eq "center") {
     $so66b="SELECTED";
}
if ($CELL55 eq "right") {
     $so66c="SELECTED";
}
if ($CELL66 eq "left") {
     $so67a="SELECTED";
}
if ($CELL66 eq "center") {
     $so67b="SELECTED";
}
if ($CELL66 eq "right") {
     $so67c="SELECTED";
}
if ($NOWRAP4 eq "wrap") {
     $so68a="SELECTED";
}
else {
     $so68b="SELECTED";
}
if ($NOWRAP5 eq "wrap") {
     $so69a="SELECTED";
}
else {
     $so69b="SELECTED";
}
if ($NOWRAP6 eq "wrap") {
     $so70a="SELECTED";
}
else {
     $so70b="SELECTED";
}

     print "<td valign=\"top\" width=\"33%\"><font face=\"verdana\" size=\"2\">\n";

     print "Cells Background Color - include # sign if using hex<br>\n";
     print "<input type=\"text\" name=\"tcolor1\" value=\"$TCOLOR1\" size=\"7\"><br><br>\n";

     print "Text Cell Align:<br><br>Stars cell align:<br>\n";
     print "&nbsp;<select name=\"cell11\"><option name=\"cell11\" value=\"left\" $so62a>left\n";
     print "<option name=\"cell11\" value=\"center\" $so62b>center\n";
     print "<option name=\"cell11\" value=\"right\" $so62c>right</select><br>\n";
     print "Average cell align:<br>\n";
     print "&nbsp;<select name=\"cell22\"><option name=\"cell22\" value=\"left\" $so63a>left\n";
     print "<option name=\"cell22\" value=\"center\" $so63b>center\n";
     print "<option name=\"cell22\" value=\"right\" $so63c>right</select><br>\n";
     print "Topic Total cell align:<br>\n";
     print "&nbsp;<select name=\"cell33\"><option name=\"cell33\" value=\"left\" $so64a>left\n";
     print "<option name=\"cell33\" value=\"center\" $so64b>center\n";
     print "<option name=\"cell33\" value=\"right\" $so64c>right</select><br>\n";
     print "Topic Title cell align:<br>\n";
     print "&nbsp;<select name=\"cell44\"><option name=\"cell44\" value=\"left\" $so65a>left\n";
     print "<option name=\"cell44\" value=\"center\" $so65b>center\n";
     print "<option name=\"cell44\" value=\"right\" $so65c>right</select><br>\n";
     print "Description cell align:<br>\n";
     print "&nbsp;<select name=\"cell55\"><option name=\"cell55\" value=\"left\" $so66a>left\n";
     print "<option name=\"cell55\" value=\"center\" $so66b>center\n";
     print "<option name=\"cell55\" value=\"right\" $so66c>right</select><br>\n";
     print "Rate It cell align:<br>\n";
     print "&nbsp;<select name=\"cell66\"><option name=\"cell66\" value=\"left\" $so67a>left\n";
     print "<option name=\"cell66\" value=\"center\" $so67b>center\n";
     print "<option name=\"cell66\" value=\"right\" $so67c>right</select><br><br>\n";
     print "NOWRAP options:<br><br>\n";
     print "Title cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap4\"><option name=\"nowrap4\" value=\"wrap\" $so68a>wrap ok\n";
     print "<option name=\"nowrap4\" value=\"nowrap\" $so68b>nowrap</select><br>\n";
     print "Description cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap5\"><option name=\"nowrap5\" value=\"wrap\" $so69a>wrap ok\n";
     print "<option name=\"nowrap5\" value=\"nowrap\" $so69b>nowrap</select><br>\n";
     print "Description Title cell Wrap:<br>\n";
     print "&nbsp;<select name=\"nowrap6\"><option name=\"nowrap6\" value=\"wrap\" $so70a>wrap ok\n";
     print "<option name=\"nowrap6\" value=\"nowrap\" $so70b>nowrap</select><br><br><br>\n";

     print "<b>Page Text Color</b><br><br>Text Font Color - include # sign if using hex.<br>This is the text displayed on each Single Topic Page, below the rate section and above the footer.\n";
     print " You can create this text for each Topic on Pref Page 2.<br>\n";
     print "<input type=\"text\" name=\"fcv3\" value=\"$FONTCOLORV3\" size=\"7\"></td></tr><tr>\n";
     print "<td align=\"center\" colspan=\"3\"><br><br><br>\n";

print "<input type=\"hidden\" name=\"uname\" value=\"$FORM{'uname'}\"><input type=\"hidden\" name=\"pword\" value=\"$FORM{'pword'}\">\n";
print "<input type=\"hidden\" name=\"getprefs\" value=\"getprefp4\">\n";

     print "<input type=\"submit\" value=\"SAVE CHANGES\"><br><br></td>\n";
     print "</form></tr></table><hr><br>\n";

&footedit2;

}

##########getprefp4b

sub getprefp4b {

&parseform;

     print "Content-type:text/html\n\n";

     open (DATAFILE, "<$config_path") || &errorfile;
@dataline=<DATAFILE>;
foreach $datafi(@dataline) {
chomp ($datafi);
}
close (DATAFILE);

     open (DATAFILE, ">$config_path") || &errorfile;

if ($FLOCKIT eq "yes") {
flock DATAFILE, 2;
}

@datanum=('0' .. '74');
$varpre="@dataline";

foreach $vari (@datanum) {

print DATAFILE "$dataline[$vari]\n";
}

if ($FORM{'tablalign3a'} eq "center") {
     $tablalign3a="<center>";
     $tablalign4a="</center>";
}
if ($FORM{'tablalign3a'} eq "left") {
     $tablalign3a="<left>";
     $tablalign4a="</left>";
}

print DATAFILE "\$HEADTITLE2=\"$FORM{'headtitle2'}\"\;\n";
print DATAFILE "\$FONTCOLORH2=\"$FORM{'fontcolorh2'}\"\;\n";
print DATAFILE "\$HEADAL2=\"$FORM{'headal2'}\"\;\n";
print DATAFILE "\$WANTTOTAL2=\"$FORM{'wanttotal2'}\"\;\n";
print DATAFILE "\$VOTETEXT2=\"$FORM{'votetext2'}\"\;\n";
print DATAFILE "\$FONTCOLORV2=\"$FORM{'fontcolorv2'}\"\;\n";
print DATAFILE "\$FOOTAL2=\"$FORM{'footal2'}\"\;\n";
print DATAFILE "\$ASKSTARS2=\"$FORM{'askstars2'}\"\;\n";
print DATAFILE "\$ASKAVERAGE2=\"$FORM{'askaverage2'}\"\;\n";
print DATAFILE "\$ASKTOTAL2=\"$FORM{'asktotal2'}\"\;\n";
print DATAFILE "\$ASKTITLE2=\"$FORM{'asktitle2'}\"\;\n";
print DATAFILE "\$ASKDESCRIP2=\"$FORM{'askdescrip2'}\"\;\n";
print DATAFILE "\$ASKRATE2=\"$FORM{'askrate2'}\"\;\n";
print DATAFILE "\$ASKRATE2U=\"$FORM{'askrate2u'}\"\;\n";
print DATAFILE "\$ASKSTAY2=\"$FORM{'askstay2'}\"\;\n";
print DATAFILE "\$ASKSTAYW2=\"$FORM{'askstayw2'}\"\;\n";
print DATAFILE "\$ASKWINDOW2=\"$FORM{'askwindow2'}\"\;\n";
print DATAFILE "\$ASKDISHEAD2=\"$FORM{'askdishead2'}\"\;\n";
print DATAFILE "\$TCOLOR11=\"$FORM{'tcolor11'}\"\;\n";
print DATAFILE "\$FONTCOLORT2=\"$FORM{'fontcolort2'}\"\;\n";
print DATAFILE "\$TITLESTARS2=\"$FORM{'titlestars2'}\"\;\n";
print DATAFILE "\$TITLEAVERAGE2=\"$FORM{'titleaverage2'}\"\;\n";
print DATAFILE "\$TITLETOTAL2=\"$FORM{'titletotal2'}\"\;\n";
print DATAFILE "\$TITLETITLE2=\"$FORM{'titletitle2'}\"\;\n";
print DATAFILE "\$TITLEDESCRIP2=\"$FORM{'titledescrip2'}\"\;\n";
print DATAFILE "\$TITLERATE2=\"$FORM{'titlerate2'}\"\;\n";
print DATAFILE "\$FONTCOLORP2=\"$FORM{'fontcolorp2'}\"\;\n";
print DATAFILE "\$TABLALIGN3A=\"$tablalign3a\"\;\n";
print DATAFILE "\$TABLALIGN4A=\"$tablalign4a\"\;\n";
print DATAFILE "\$TABHEIGHT2=\"$FORM{'tabheight2'}\"\;\n";
print DATAFILE "\$TABWIDTH2=\"$FORM{'tabwidth2'}\"\;\n";
print DATAFILE "\$CELLPADDING2=\"$FORM{'cellpadding2'}\"\;\n";
print DATAFILE "\$CELLSPACING2=\"$FORM{'cellspacing2'}\"\;\n";
print DATAFILE "\$BORDER2=\"$FORM{'border2'}\"\;\n";
print DATAFILE "\$TCOLOR1=\"$FORM{'tcolor1'}\"\;\n";
print DATAFILE "\$CELL11=\"$FORM{'cell11'}\"\;\n";
print DATAFILE "\$CELL22=\"$FORM{'cell22'}\"\;\n";
print DATAFILE "\$CELL33=\"$FORM{'cell33'}\"\;\n";
print DATAFILE "\$CELL44=\"$FORM{'cell44'}\"\;\n";
print DATAFILE "\$CELL55=\"$FORM{'cell55'}\"\;\n";
print DATAFILE "\$CELL66=\"$FORM{'cell66'}\"\;\n";
print DATAFILE "\$NOWRAP4=\"$FORM{'nowrap4'}\"\;\n";
print DATAFILE "\$NOWRAP5=\"$FORM{'nowrap5'}\"\;\n";
print DATAFILE "\$NOWRAP6=\"$FORM{'nowrap6'}\"\;\n";
print DATAFILE "\$FONTCOLORV3=\"$FORM{'fcv3'}\"\;\n";
print DATAFILE "$dataline[120]";

if ($FLOCKIT eq "yes") {
flock DATAFILE, 8;
}

close (DATAFILE);

     print "<html><head><title>Stars Admin</title><META HTTP-EQUIV=\"no-cache\"></head><body bgcolor=\"#FFFFCC\">\n";
     print "<center><table width=\"80%\"><td><font face=\"verdana\" size=\"3\" color=\"red\"><b>Preference Page 4 - Single Topic Page variables have been UPDATED.<br><br></b></font>\n";

     print "<font face=\"verdana\" size=\"2\" color=\"#000000\"><b>\n";
     print "<a href=\"http://bandley3.com/scripts/5starrating/index.shtml\" target=\"_blank\">DEMO</a><br>\n";
     print "<a href=\"http://bandley3.com/help/index.shtml\" target=\"_blank\">HELP</a><br><br>\n";
     print "The only 2 Preference Pages you MUST fill out are Pages 1 and 2.<br><br>\n";

&getprefhead;

     print "<br><br></b></font></td></table></center>\n";

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";


exit;
}


##########errorit
sub errorit {

     print "Content-type:text/html\n\n";
     print "<html><body>\n";
     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"black\"><b>Invalid call to this script.</b></font></td></table></center>\n";
     print "</body></html>\n";

exit;
  }

##########errorfile
sub errorfile {

     print "Content-type:text/html\n\n";
     print "<html><body>\n";
     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"black\"><b>File or Directory cannot be opened.<br><br>Default error message.</b></font></td></table></center>\n";
     print "</body></html>\n";

exit;
  }

##########footedit

sub footedit {

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";
exit;
}
##########footedit2

sub footedit2 {

     print "<font face=\"verdana\" size=\"2\"><b><br><br><a href=\"$SCRIPTURL\" target=\"_blank\">View your current script in new window.</a>\n";
     print "<br><br><a href=\"http://bandley3.com/\" target=\"_blank\">&copy; 2000 Bandley3.com</a><br><br></b></font></body></html>\n";
exit;
}