#!/usr/bin/perl
#Location of perl on your server

#
#  Bandley3.com's ActualTime v1.0
#  UNIX (Debian Linux) tested
#  Copyright 2000 Bandley3.com
#  http://bandley3.com
#  cfs@mac.com
#
##########
#
#  Licensing Agreement
#
#  Installing this script constitutes acceptance of the licensing agreement found
#  at Bandley3.com and in the LICENSE document packaged with this script.
#  Although ActualTime is a free script, all copyright laws apply. This script is
#  not to be sold, redistributed, or repackaged in any way.
#  Bandley3.com's ActualTime is a licensed product.
#
#
##########

###
### QUICKSTART - as Server-Side Include
### 
### The only 2 variables you must fill out are the location of perl above,
### and the first variable below (INCREMENT SERVER'S TIME).
###
### IMPORTANT: If you are using this script as a time stamper for
### another perl script, the other variables may be obsolete. More
### explanation in the README.txt.
###
### Upload this script and chmod it 755 or 777.
###
### Call this script via a 'server-side include' (yourpage.shtml)
### example (in same directory)-
### <!--#include virtual="actualtime.pl?new"-->
### If lower level directory, include relative path
### example- <!--#include virtual="stuff/actualtime.pl?new"-->
### If higher level directory, include relative path
### example- <!--#include virtual="../actualtime.pl?new"-->
### IMPORTANT- the ?new following script name is manditory.
### IMPORTANT- a space or spaces following the <!-- or preceeding the -->
### may stop the include from functioning.
###
### To use this script as a time stamper or to call its subroutines
### for other perl scripts, like for message boards etc., see
### README.txt or go to the address below for info.
### http://bandley3.com/help/
###


#
# INCREMENT SERVER'S TIME - this is the difference in hours you are from your server.
# Use 0 if you are in the same time zone as your server. Use up to -11 if you are behind
# your server (you DO need the minus sign). Use up to +12 if you're ahead of your server
#(you DON'T need the plus sign).
# example-Server is in California. You are in New York. Set this variable to 3
#
$timech="3";

#
# DEFINE FONT - change as you like. Hex ok for color.
#
$ACFONTCOLOR="black";
$ACFONTFACE="verdana";
$ACFONTSIZE="2";


#
# DEFINE DISPLAY - answer the next 6, yes or no
#
# Do you want date and time centered?
$ACCENTER="no";
# Do you want weekday displayed?
$ACWEEKDAY="yes";
# Do you want date displayed?
$ACDISDATE="yes";
# If yes to previous question, do you want month displayed as a number?
# (Month displays as text if you answer no.)
$ACDATEASNUM="no";
# Do you want year displayed?
$ACDISYEAR="yes";
# Do you want time displayed?
$ACTIMEDIS="yes";


#
# TIME TEXT - this is in case you'd like your time zone displayed.
# example - EST for eastern standard time.
# NOTE: this does not affect the actual timer. It just displays text you specify.
$ACTZONE="ET";



########## NO EDITING NECESSARY BELOW THIS LINE


$new="new";

if ($ENV{'QUERY_STRING'} eq $new) {

     print "Content-type:text/html\n\n";

&getnewtime;

}

elsif ($ENV{'QUERY_STRING'} ne $new) {

#################### BEGIN - MAY NEED REMOVED

     print "Content-type:text/html\n\n";

#################### END - MAY NEED REMOVED

print "\n";

}


##########getnewstamp

sub getnewstamp {


############################ SERVERTIME

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime (time);

$min=sprintf ("%02d", $min);
$sec=sprintf ("%02d", $sec);

$year2=$year + 1900;
$monp=$mon +1;


########## INCREMENT SERVERTIME

$hourmov=$hour + $timech;

############################ DAILY ROLLOVERS


if ($hourmov >= 24) {
$mdayp=$mday +1;
$moveplus="yes";
}
elsif ($hourmov < 0) {
$mdayp=$mday -1;
$moveminus="yes";
}
else {
$mdayp=$mday;
}


########## DEFINE LEAPYEARS


@feb=(2004, 2008, 2012, 2016, 2020, 2024, 2028, 2032, 2036, 2040, 2044, 2048, 2052, 2056, 2060, 2064, 2068, 2072, 2076, 2080, 2084, 2088, 2092, 2096);


########## MONTH/DAY/YEAR/WEEKDAY ROLLOVERS GET DEFINED


if ($moveminus eq "yes") {

 if ($wday eq "1") {
 $wday="Sunday"
 }
 if ($wday eq "2") {
 $wday="Monday"
 }
 if ($wday eq "3") {
 $wday="Tuesday"
 }
 if ($wday eq "4") {
 $wday="Wednesday"
 }
 if ($wday eq "5") {
 $wday="Thursday"
 }
 if ($wday eq "6") {
 $wday="Friday"
 }
 if ($wday eq "0") {
 $wday="Saturday"
 }

   if ($mdayp eq "0") {

     if ($monp eq "1") {
     $monp=12;
     $mdayp=31;
     $year2=$year2 -1;
     }
     elsif ($monp eq "2") {
     $monp=1;
     $mdayp=31;
     }
     elsif ($monp eq "3") {
          $monp=2;
          $mdayp=28;

          foreach $leapyear (@feb) {
          if ($year2 eq $leapyear) {
          $monp=2;
          $mdayp=29;
          }
         }
     }
     elsif ($monp eq "4") {
     $monp=3;
     $mdayp=31;
     }
     elsif ($monp eq "5") {
     $monp=4;
     $mdayp=30;
     }
     elsif ($monp eq "6") {
     $monp=5;
     $mdayp=31;
     }
     elsif ($monp eq "7") {
     $monp=6;
     $mdayp=30;
     }
     elsif ($monp eq "8") {
     $monp=7;
     $mdayp=31;
     }
     elsif ($monp eq "9") {
     $monp=8;
     $mdayp=31;
     }
     elsif ($monp eq "10") {
     $monp=9;
     $mdayp=30;
     }
     elsif ($monp eq "11") {
     $monp=10;
     $mdayp=31;
     }
     elsif ($monp eq "12") {
     $monp=11;
     $mdayp=30;
     }

 }
}

if ($moveplus eq "yes") {

 if ($wday eq "1") {
 $wday="Tuesday"
 }
 if ($wday eq "2") {
 $wday="Wednesday"
 }
 if ($wday eq "3") {
 $wday="Thursday"
 }
 if ($wday eq "4") {
 $wday="Friday"
 }
 if ($wday eq "5") {
 $wday="Saturday"
 }
 if ($wday eq "6") {
 $wday="Sunday"
 }
 if ($wday eq "0") {
 $wday="Monday"
 }

     if (($monp eq "1") && ($mdayp eq "32")) {
     $monp=2;
     $mdayp=1;
     }
     if (($monp eq "2") && ($mdayp eq "30")) {
     $monp=3;
     $mdayp=1;
     }
     if (($monp eq "2") && ($mdayp eq "29")) {
     $monp=3;
     $mdayp=1;

          foreach $leapyear (@feb) {
          if ($year2 eq $leapyear) {
          $monp=2;
          $mdayp=29;
          }
         }

     }
     if (($monp eq "3") && ($mdayp eq "32")) {
     $monp=4;
     $mdayp=1;
     }
     if (($monp eq "4") && ($mdayp eq "31")) {
     $monp=5;
     $mdayp=1;
     }
     if (($monp eq "5") && ($mdayp eq "32")) {
     $monp=6;
     $mdayp=1;
     }
     if (($monp eq "6") && ($mdayp eq "31")) {
     $monp=7;
     $mdayp=1;
     }
     if (($monp eq "7") && ($mdayp eq "32")) {
     $monp=8;
     $mdayp=1;
     }
     if (($monp eq "8") && ($mdayp eq "32")) {
     $monp=9;
     $mdayp=1;
     }
     if (($monp eq "9") && ($mdayp eq "31")) {
     $monp=10;
     $mdayp=1;
     }
     if (($monp eq "10") && ($mdayp eq "32")) {
     $monp=11;
     $mdayp=1;
     }
     if (($monp eq "11") && ($mdayp eq "31")) {
     $monp=12;
     $mdayp=1;
     }
     if (($monp eq "12") && ($mdayp eq "32")) {
     $monp=1;
     $mdayp=1;
     $year2=$year2 +1;
     }
 }

############################ INCREMENTED TIME DEFINED


if ($hour eq "0") {
$hourz=24;
}
else {
$hourz=$hour;
}

$houry=$hourz + $timech;


if ($houry eq "0") {
$hourp=12;
$houra="am";
}

elsif ($houry eq "24") {
$hourp=12;
$houra="am";
}

elsif ($houry eq "12") {
$hourp=12;
$houra="pm";
}

elsif ($houry < 0) {
$hourp=$houry + 24;
}

elsif (($houry > 0) && ($houry < 12)) {
$hourp=$houry;
$houra="am";
}

elsif (($houry > 12) && ($houry < 24)) {
$hourp=$houry;
}

elsif ($houry > 24) {
$hourp=$houry - 24;
$houra="am";
}

     if ($hourp eq "13") {
     $hourp=1;
     $houra="pm";
     }
     elsif ($hourp eq "14") {
     $hourp=2;
     $houra="pm";
     }
     elsif ($hourp eq "15") {
     $hourp=3;
     $houra="pm";
     }
     elsif ($hourp eq "16") {
     $hourp=4;
     $houra="pm";
     }
     elsif ($hourp eq "17") {
     $hourp=5;
     $houra="pm";
     }
     elsif ($hourp eq "18") {
     $hourp=6;
     $houra="pm";
     }
     elsif ($hourp eq "19") {
     $hourp=7;
     $houra="pm";
     }
     elsif ($hourp eq "20") {
     $hourp=8;
     $houra="pm";
     }
     elsif ($hourp eq "21") {
     $hourp=9;
     $houra="pm";
     }
     elsif ($hourp eq "22") {
     $hourp=10;
     $houra="pm";
     }
     elsif ($hourp eq "23") {
     $hourp=11;
     $houra="pm";
     }

############################ DEFINE DAY NAMES if UNCHANGED

if ($wday eq "1") {
$wday="Monday";
}
if ($wday eq "2") {
$wday="Tuesday";
}
if ($wday eq "3") {
$wday="Wednesday";
}
if ($wday eq "4") {
$wday="Thursday";
}
if ($wday eq "5") {
$wday="Friday";
}
if ($wday eq "6") {
$wday="Saturday";
}
if ($wday eq "0") {
$wday="Sunday";
}

############################ CONVERT MONTH NUMBERS to TEXT

if ($monp eq "1") {
$monpt="January";
}
if ($monp eq "2") {
$monpt="February";
}
if ($monp eq "3") {
$monpt="March";
}
if ($monp eq "4") {
$monpt="April";
}
if ($monp eq "5") {
$monpt="May";
}
if ($monp eq "6") {
$monpt="June";
}
if ($monp eq "7") {
$monpt="July";
}
if ($monp eq "8") {
$monpt="August";
}
if ($monp eq "9") {
$monpt="September";
}
if ($monp eq "10") {
$monpt="October";
}
if ($monp eq "11") {
$monpt="November";
}
if ($monp eq "12") {
$monpt="December";
}


$wdaybac=$wday;
$monpbac=$monp;
$monptbac=$monpt;
$mdaypbac=$mdayp;
$year2bac=$year2;
$hourpbac=$hourp;
$minbac=$min;
$hourabac=$houra;

}


##########getnewtime

sub getnewtime {


############################ SERVERTIME

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime (time);

$min=sprintf ("%02d", $min);
$sec=sprintf ("%02d", $sec);

$year2=$year + 1900;
$monp=$mon +1;


########## INCREMENT SERVERTIME

$hourmov=$hour + $timech;

############################ DAILY ROLLOVERS


if ($hourmov >= 24) {
$mdayp=$mday +1;
$moveplus="yes";
}
elsif ($hourmov < 0) {
$mdayp=$mday -1;
$moveminus="yes";
}
else {
$mdayp=$mday;
}


########## DEFINE LEAPYEARS


@feb=(2004, 2008, 2012, 2016, 2020, 2024, 2028, 2032, 2036, 2040, 2044, 2048, 2052, 2056, 2060, 2064, 2068, 2072, 2076, 2080, 2084, 2088, 2092, 2096);


########## MONTH/DAY/YEAR/WEEKDAY ROLLOVERS GET DEFINED


if ($moveminus eq "yes") {

 if ($wday eq "1") {
 $wday="Sunday"
 }
 if ($wday eq "2") {
 $wday="Monday"
 }
 if ($wday eq "3") {
 $wday="Tuesday"
 }
 if ($wday eq "4") {
 $wday="Wednesday"
 }
 if ($wday eq "5") {
 $wday="Thursday"
 }
 if ($wday eq "6") {
 $wday="Friday"
 }
 if ($wday eq "0") {
 $wday="Saturday"
 }

   if ($mdayp eq "0") {

     if ($monp eq "1") {
     $monp=12;
     $mdayp=31;
     $year2=$year2 -1;
     }
     elsif ($monp eq "2") {
     $monp=1;
     $mdayp=31;
     }
     elsif ($monp eq "3") {
          $monp=2;
          $mdayp=28;

          foreach $leapyear (@feb) {
          if ($year2 eq $leapyear) {
          $monp=2;
          $mdayp=29;
          }
         }
     }
     elsif ($monp eq "4") {
     $monp=3;
     $mdayp=31;
     }
     elsif ($monp eq "5") {
     $monp=4;
     $mdayp=30;
     }
     elsif ($monp eq "6") {
     $monp=5;
     $mdayp=31;
     }
     elsif ($monp eq "7") {
     $monp=6;
     $mdayp=30;
     }
     elsif ($monp eq "8") {
     $monp=7;
     $mdayp=31;
     }
     elsif ($monp eq "9") {
     $monp=8;
     $mdayp=31;
     }
     elsif ($monp eq "10") {
     $monp=9;
     $mdayp=30;
     }
     elsif ($monp eq "11") {
     $monp=10;
     $mdayp=31;
     }
     elsif ($monp eq "12") {
     $monp=11;
     $mdayp=30;
     }

 }
}

if ($moveplus eq "yes") {

 if ($wday eq "1") {
 $wday="Tuesday"
 }
 if ($wday eq "2") {
 $wday="Wednesday"
 }
 if ($wday eq "3") {
 $wday="Thursday"
 }
 if ($wday eq "4") {
 $wday="Friday"
 }
 if ($wday eq "5") {
 $wday="Saturday"
 }
 if ($wday eq "6") {
 $wday="Sunday"
 }
 if ($wday eq "0") {
 $wday="Monday"
 }

     if (($monp eq "1") && ($mdayp eq "32")) {
     $monp=2;
     $mdayp=1;
     }
     if (($monp eq "2") && ($mdayp eq "30")) {
     $monp=3;
     $mdayp=1;
     }
     if (($monp eq "2") && ($mdayp eq "29")) {
     $monp=3;
     $mdayp=1;

          foreach $leapyear (@feb) {
          if ($year2 eq $leapyear) {
          $monp=2;
          $mdayp=29;
          }
         }

     }
     if (($monp eq "3") && ($mdayp eq "32")) {
     $monp=4;
     $mdayp=1;
     }
     if (($monp eq "4") && ($mdayp eq "31")) {
     $monp=5;
     $mdayp=1;
     }
     if (($monp eq "5") && ($mdayp eq "32")) {
     $monp=6;
     $mdayp=1;
     }
     if (($monp eq "6") && ($mdayp eq "31")) {
     $monp=7;
     $mdayp=1;
     }
     if (($monp eq "7") && ($mdayp eq "32")) {
     $monp=8;
     $mdayp=1;
     }
     if (($monp eq "8") && ($mdayp eq "32")) {
     $monp=9;
     $mdayp=1;
     }
     if (($monp eq "9") && ($mdayp eq "31")) {
     $monp=10;
     $mdayp=1;
     }
     if (($monp eq "10") && ($mdayp eq "32")) {
     $monp=11;
     $mdayp=1;
     }
     if (($monp eq "11") && ($mdayp eq "31")) {
     $monp=12;
     $mdayp=1;
     }
     if (($monp eq "12") && ($mdayp eq "32")) {
     $monp=1;
     $mdayp=1;
     $year2=$year2 +1;
     }
 }

############################ INCREMENTED TIME DEFINED


if ($hour eq "0") {
$hourz=24;
}
else {
$hourz=$hour;
}

$houry=$hourz + $timech;


if ($houry eq "0") {
$hourp=12;
$houra="am";
}

elsif ($houry eq "24") {
$hourp=12;
$houra="am";
}

elsif ($houry eq "12") {
$hourp=12;
$houra="pm";
}

elsif ($houry < 0) {
$hourp=$houry + 24;
}

elsif (($houry > 0) && ($houry < 12)) {
$hourp=$houry;
$houra="am";
}

elsif (($houry > 12) && ($houry < 24)) {
$hourp=$houry;
}

elsif ($houry > 24) {
$hourp=$houry - 24;
$houra="am";
}

     if ($hourp eq "13") {
     $hourp=1;
     $houra="pm";
     }
     elsif ($hourp eq "14") {
     $hourp=2;
     $houra="pm";
     }
     elsif ($hourp eq "15") {
     $hourp=3;
     $houra="pm";
     }
     elsif ($hourp eq "16") {
     $hourp=4;
     $houra="pm";
     }
     elsif ($hourp eq "17") {
     $hourp=5;
     $houra="pm";
     }
     elsif ($hourp eq "18") {
     $hourp=6;
     $houra="pm";
     }
     elsif ($hourp eq "19") {
     $hourp=7;
     $houra="pm";
     }
     elsif ($hourp eq "20") {
     $hourp=8;
     $houra="pm";
     }
     elsif ($hourp eq "21") {
     $hourp=9;
     $houra="pm";
     }
     elsif ($hourp eq "22") {
     $hourp=10;
     $houra="pm";
     }
     elsif ($hourp eq "23") {
     $hourp=11;
     $houra="pm";
     }

############################ DEFINE DAY NAMES if UNCHANGED

if ($wday eq "1") {
$wday="Monday";
}
if ($wday eq "2") {
$wday="Tuesday";
}
if ($wday eq "3") {
$wday="Wednesday";
}
if ($wday eq "4") {
$wday="Thursday";
}
if ($wday eq "5") {
$wday="Friday";
}
if ($wday eq "6") {
$wday="Saturday";
}
if ($wday eq "0") {
$wday="Sunday";
}

############################ CONVERT MONTH NUMBERS to TEXT

if ($monp eq "1") {
$monpt="January";
}
if ($monp eq "2") {
$monpt="February";
}
if ($monp eq "3") {
$monpt="March";
}
if ($monp eq "4") {
$monpt="April";
}
if ($monp eq "5") {
$monpt="May";
}
if ($monp eq "6") {
$monpt="June";
}
if ($monp eq "7") {
$monpt="July";
}
if ($monp eq "8") {
$monpt="August";
}
if ($monp eq "9") {
$monpt="September";
}
if ($monp eq "10") {
$monpt="October";
}
if ($monp eq "11") {
$monpt="November";
}
if ($monp eq "12") {
$monpt="December";
}


############################ PRINT BASED ON VARIABLES


if ($ACCENTER eq "yes") {

     print "<center>\n";

     print "<font face=\"$ACFONTFACE\" size=\"$ACFONTSIZE\" color=\"$ACFONTCOLOR\">\n";

     if ($ACWEEKDAY eq "yes") {
     print "$wday\n";
     }
     if ($ACDISDATE eq "no") {
     print "\n";
     }
     elsif (($ACDISDATE eq "yes") && ($ACDATEASNUM eq "yes")) {
     print " &nbsp;$monp/$mdayp";
               if ($ACDISYEAR eq "yes") {
               print "/$year2\n";
               }
     }
     elsif (($ACDISDATE eq "yes") && ($ACDATEASNUM eq "no")) {
     print " &nbsp;$monpt $mdayp";
               if ($ACDISYEAR eq "yes") {
               print ", $year2\n";
               }
     }

     if ($ACTIMEDIS eq "yes") {
     print " &nbsp;$hourp:$min $houra\n";
     }


     print "&nbsp;$ACTZONE\n";

     print "</font>\n";

     print "</center>\n";
}
else {


     print "<font face=\"$ACFONTFACE\" size=\"$ACFONTSIZE\" color=\"$ACFONTCOLOR\">\n";

     if ($ACWEEKDAY eq "yes") {
     print "$wday\n";
     }
     if ($ACDISDATE eq "no") {
     print "\n";
     }
     elsif (($ACDISDATE eq "yes") && ($ACDATEASNUM eq "yes")) {
     print " &nbsp;$monp/$mdayp";
               if ($ACDISYEAR eq "yes") {
               print "/$year2\n";
               }
     }
     elsif (($ACDISDATE eq "yes") && ($ACDATEASNUM eq "no")) {
     print " &nbsp;$monpt $mdayp";
               if ($ACDISYEAR eq "yes") {
               print ", $year2\n";
               }
     }

     if ($ACTIMEDIS eq "yes") {
     print " &nbsp;$hourp:$min $houra\n";
     }


     print "&nbsp;$ACTZONE\n";

     print "</font>\n";

}
}
1;