#!/usr/bin/perl

########## do not alter the following block of code
$ENV{'QUERY_STRING'} =~ s/\|//g;
$ENV{'QUERY_STRING'} =~ s/\x00//g;
$ENV{'QUERY_STRING'} =~ s/\%00//g;
$ENV{'QUERY_STRING'} =~ s/\.\.\///g;
$ENV{'QUERY_STRING'} =~ s/\%2E//ig;
$ENV{'QUERY_STRING'} =~ s/\%2F//ig;
########## end of block

#The root path of the sconfig.pl, including the sconfig.pl name itself.
$config_path="/home/sites/423a/stars/sconfig.pl";

##########
#
#  Bandley3.com's 5 Star Rating v3.0
#  Apache-Mac Apache-PC tested
#  Copyright 2000-2002 Bandley3.com
#  http://bandley3.com
#  cfs@mac.com
#
##########
#
#  Licensing Agreement
#
#  Purchasing a license and/or installing this script constitutes
#  acceptance of the licensing agreement you read before purchasing
#  said license. This agreement can be found at Bandley3.com and in
#  the README.Stars document packaged with this script.
#  Bandley3.com's 5 Star Rating is licensed, not sold.
#
#
##########


########## No editing necessary below this point


require "$config_path";


open (HEADER, "<$HEADPATH/header.txt") || &errorfile;
@header = <HEADER>;
close(HEADER);

open (FOOTER, "<$HEADPATH/footer.txt") || &errorfile;
@footer = <FOOTER>;
close(FOOTER);

open (HEADERW, "<$HEADPATH/headerv.txt") || &errorfile;
@headerw = <HEADERW>;
close(HEADERW);

open (FOOTERW, "<$HEADPATH/footerv.txt") || &errorfile;
@footerw = <FOOTERW>;
close(FOOTERW);

if ($ENV{'HTTP_REFERER'} eq "$SCRIPTURL2?$ENV{'QUERY_STRING'}") {

     if ($ASKSTAYW eq "no") {
     &getrateitt;
     }
     else {
     &getrateitd;
     }
}


elsif ($ENV{'QUERY_STRING'} eq 'govostar') {
     &checkreferer;
}

elsif ($ENV{'QUERY_STRING'} eq 'getaver') {
     &getaver;
}

elsif (!$ENV{'QUERY_STRING'}) {
     &getaver;
}


else {

     if (($ASKSTAY eq "yes") && ($LINKTITLE eq "yes")) {
          if ($ASKSTAYW eq "yes") {
     &getrateitd;
          }
          else {
     &getrateitm;
          }
     }
     else {
     &getrateitm;
     }

}

##########checkreferer

sub checkreferer {

$sttref=$VALIDREFERER;
$sttref =~ s/^(www\.)//i;

     if ($VALIDREF eq "no") {
     &parseform;
  }
     elsif (($VALIDREF eq "yes") && ($ENV{'HTTP_REFERER'} =~m|https?://(www\.)?$sttref|i)) {
     &parseform;
  }

else {
     print "Content-type:text/html\n\n";
     print @headerw;
     print "<center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b>This script cannot be called from other sites.</b></font></center>\n";
     print "</body></html>\n";
exit;
  }
}

##########parseform

sub parseform {
 
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/<!--(.|\n)*-->//g;
$value =~s/"//g;
$value =~s/;//g;
$value =~ s/\|//g;
$value =~ s/\x00//g;
$value =~ s/\%00//g;
$value =~ s/\.\.\///g;
$value =~ s/\%2E//ig;
$value =~ s/\%2F//ig;
$FORM{$name} = $value;
 }
&getinput;
}


##########getinput

sub getinput {

##### begin file locking trap


if ($FLOCKIT eq "yes") {
     open (DATA, "<$config_path") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATA, 2;
}
if ($FLOCKIT eq "yes") {
flock DATA, 8;
}
close(DATA);
}

##### end file locking trap


if(!$FORM{'rate'}) {
     &errorblank;
 }
if($FORM{'rate'} eq "1") {
     $value1 = 1;
$stargif="one";
 }
if($FORM{'rate'} eq "2") {
     $value2 = 1;
$stargif="two";
 }
if($FORM{'rate'} eq "3") {
     $value3 = 1;
$stargif="three";
 }
if($FORM{'rate'} eq "4") {
     $value4 = 1;
$stargif="four";
 }
if($FORM{'rate'} eq "5") {
     $value5 = 1;
$stargif="five";
 }
if($FORM{'subject'}) {
     $subject = $FORM{'subject'};
 }

#####checkip

     open (DATA, "<$DATAPATH/$subject.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     if (($CHECKIP eq "yes") && ($sdata[6] eq $ENV{'REMOTE_ADDR'})) {

&errorvote;

 }
   else {


$star1 = $value1+$sdata[1];
$star2 = $value2+$sdata[2];
$star3 = $value3+$sdata[3];
$star4 = $value4+$sdata[4];
$star5 = $value5+$sdata[5];

     open (DATA, ">$DATAPATH/$subject.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock DATA, 2;
}
     print DATA "$sdata[0];$star1;$star2;$star3;$star4;$star5;$ENV{'REMOTE_ADDR'};$sdata[7];$sdata[8];$sdata[9]";
close (DATA);

     open (VFILE, "<$LISTPATH/stlist.txt") || &errorfile;
@vfile = <VFILE>;
close (VFILE);

     open (VFILE, ">$LISTPATH/stlist.txt") || &errorfile;
if ($FLOCKIT eq "yes") {
flock VFILE, 2;
}

$vototal = $vfile[0]+1;

     print VFILE "$vototal";

close (VFILE);
}
&thanks;

}


##########getaver

sub getaver {

     print "Content-type:text/html\n\n";
     print @header;

if ($HEADYES eq "yes") {
     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\">\n";
     print "<td align=\"$HEADAL\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORH\"><b>$HEADTITLE</b></font></td></table>$TABLA2\n";
}
else {
     print "\n";
}
     print "$TABLA1<table width=\"$TABWIDTH\" height=\"$TABHEIGHT\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\" border=\"$BORDER\">\n";

if ($ASKDISHEAD eq "yes") {

     print "<tr>\n";

if ($ASKSTARS eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLESTARS</b></font></td>\n";
}

if ($ASKAVERAGE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLEAVERAGE</b></font></td>\n";
}

if ($ASKTOTAL eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLETOTAL</b></font></td>\n";
}

if ($ASKTITLE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLETITLE</b></font></td>\n";
}

if ($ASKDESCRIP eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\" $NOWRAP3><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLEDESCRIP</b></font></td>\n";
}

if ($ASKRATE eq "yes") {
     print "<td align=\"$HCELL1\" bgcolor=\"$COLOR11\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORT\"><b>$TITLERATE</b></font></td>\n";
}
print "</tr>\n";
}


     open (FILE, "<$LISTPATH/slist.txt") || &errorfile;
@file = split (';', <FILE>);
close (FILE);

if ($SORTORDER eq "recenttop") {
@file = reverse (@file);
}
if ($SORTORDER eq "alpha") {
@file = sort (@file);
}

foreach $topic (@file) {

print "<tr>\n";

     open (DATA, "<$DATAPATH/$topic.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

$totalvotes=$sdata[1]+$sdata[2]+$sdata[3]+$sdata[4]+$sdata[5];

if (($totalvotes eq "0") && ($ASKSTARS eq "no")) {
     print "\n";
}

elsif (($totalvotes eq "0") && ($ASKSTARS eq "yes")) {
     print "<td align=\"$CELL1\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<img src=\"$IMGPATH/nostars.$GIFO\" border=\"0\"></td>\n";
}

elsif ($totalvotes > 0) {
$totalpoints=$sdata[1]*1+$sdata[2]*2+$sdata[3]*3+$sdata[4]*4+$sdata[5]*5;
$average=$totalpoints / $totalvotes;
$averager= sprintf("%.1f", $average);


if (($averager >= 1) && ($averager < 1.3)) {
    $starvalue="one";
}

elsif (($averager >= 1.3) && ($averager < 1.8)) {
    $starvalue="oneh";
}

elsif (($averager >= 1.8) && ($averager < 2.3)) {
    $starvalue="two";
}

elsif (($averager >= 2.3) && ($averager < 2.8)) {
    $starvalue="twoh";
}

elsif (($averager >= 2.8) && ($averager < 3.3)) {
    $starvalue="three";
}

elsif (($averager >= 3.3) && ($averager < 3.8)) {
    $starvalue="threeh";
}

elsif (($averager >= 3.8) && ($averager < 4.3)) {
    $starvalue="four";
}

elsif (($averager >= 4.3) && ($averager < 4.8)) {
    $starvalue="fourh";
}

elsif ($averager >= 4.8) {
    $starvalue="five";
}
}

if (($ASKSTARS eq "yes") && ($totalvotes > 0)) {

     print "<td align=\"$CELL1\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<img src=\"$IMGPATH/$starvalue.$GIFO\" border=\"0\"></td>\n";
}

if (($ASKAVERAGE eq "yes") && ($totalvotes > 0)) {
     print "<td align=\"$CELL2\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$averager</font></td>\n";
}
elsif (($ASKAVERAGE eq "yes") && ($totalvotes eq "0")) {
     print "<td align=\"$CELL2\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">0</font></td>\n";
}
elsif ($ASKAVERAGE eq "no") {
     print "\n";
}

if ($ASKTOTAL eq "yes") {
     print "<td align=\"$CELL3\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$totalvotes</font></td>\n";
}

     if (($ASKTITLE eq "yes") && ($LINKTITLE eq "no")) {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>$sdata[0]</b></font></td>\n";
 }
else {

if (($ASKTITLE eq "yes") && ($ASKSTAY eq "yes")) {

     if ($ASKSTAYW eq "no") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "<a href=\"$SCRIPTURL2?$topic\" onClick=\"newWindow = openWin( '$SCRIPTURL2?$topic', 'target98', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a></b></font></td>\n";
 }
     if ($ASKSTAYW eq "yes") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b><a href=\"$SCRIPTURL2?$topic\">$sdata[0]</a></b></font></td>\n";
 }
     
}

elsif (($ASKTITLE eq "yes") && ($ASKSTAY eq "no")) {

     if ($ASKSTAYW eq "no") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>\n";
     print "<a href=\"$sdata[7]\" onClick=\"newWindow = openWin( '$sdata[7]', 'target97', 'width=$BWWIDTH,height=$BWHEIGHT,toolbar=1,location=1,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\">$sdata[0]</a></td>\n";
}
     if ($ASKSTAYW eq "yes") {
     print "<td align=\"$CELL4\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b><a href=\"$sdata[7]\">$sdata[0]</a></b></font></td>\n";
 }
}
elsif ($ASKTITLE eq "no") {
     print "\n";
 }
}

if ($sdata[9] eq "") {
$sdatanine="&nbsp;&nbsp;";
}
else {
$sdatanine=$sdata[9];
}

if ($ASKDESCRIP eq "yes") {
     print "<td align=\"$CELL5\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\" $NOWRAP2>\n";
     print "<font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLOR1\">$sdatanine</font></td>\n";
}

if (($ASKRATE eq "yes") && ($ASKWINDOW eq "yes")) {
     print "<td align=\"$CELL6\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$topic\" onClick=\"newWindow = openWin( '$SCRIPTURL?$topic', 'target99', 'width=$LWWIDTH,height=$LWHEIGHT,toolbar=0,location=0,directories=0,status=1,menuBar=1,scrollbars=1,resizable=1' ); return false\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif (($ASKRATE eq "yes") && ($ASKWINDOW eq "no")) {
     print "<td align=\"$CELL6\" valign=\"$VCELL1\" bgcolor=\"$COLOR1\">\n";
     print "<a href=\"$SCRIPTURL?$topic\"><img src=\"$IMGPATH/rateit.$GIFO\" border=\"0\"></a></td>\n";
}

elsif ($ASKRATE eq "no") {
     print "\n";
}

     print "</tr>\n";
    }

     print "</table>$TABLA2\n";


if ($WANTTOTAL eq "yes") {

     open (VFILE, "<$LISTPATH/stlist.txt") || &errorfile;
@vfile = <VFILE>;
close (VFILE);

     print "$TABLA1<table width=\"$TABWIDTH\" cellpadding=\"$CELLPADDING\" cellspacing=\"$CELLSPACING\">\n";
     print "<td align=\"$FOOTAL\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\" color=\"$FONTCOLORV1\"><b>$VOTETEXT$vfile[0]</b></font></td></table>$TABLA2\n";

   }

     print @footer;

exit;

}


##########getrateitt

sub getrateitt {

     open (DATA, "<$DATAPATH/$ENV{'QUERY_STRING'}.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     print "Content-type:text/html\n\n";
     print @headerw;
     print "<center><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORW\"><b>$sdata[8]</b></font></center>\n";
print "<center><table><tr>\n";
print "<form action=\"$SCRIPTURL?govostar\" method=POST>\n";
print "<td colspan=\"5\" align=\"center\"><img src=\"$IMGPATH/five.$GIFO\" border=\"0\"><br><br></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"1\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"2\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"3\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"4\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"5\"></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>1</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>2</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>3</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>4</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>5</b></font></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\" colspan=\"5\" nowrap><br>&nbsp;&nbsp;<input type=\"submit\" value=\"Select/Then Click\">&nbsp;&nbsp;</td>\n";
print "<input type=hidden name=\"subject\" value=\"$ENV{'QUERY_STRING'}\">\n";
print "<input type=hidden name=\"thanksvar\" value=\"singlet\">\n";
print "</form>\n";
print "</tr>\n";
print "</table></center>\n";
print @footerw;
exit;
}

##########getrateitm

sub getrateitm {

     open (DATA, "<$DATAPATH/$ENV{'QUERY_STRING'}.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     print "Content-type:text/html\n\n";
     print @headerw;
     print "<center><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORW\"><b>$sdata[8]</b></font></center>\n";
print "<center><table><tr>\n";
print "<form action=\"$SCRIPTURL?govostar\" method=POST>\n";
print "<td colspan=\"5\" align=\"center\"><img src=\"$IMGPATH/five.$GIFO\" border=\"0\"><br><br></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"1\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"2\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"3\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"4\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"5\"></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>1</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>2</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>3</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>4</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>5</b></font></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\" colspan=\"5\" nowrap><br>&nbsp;&nbsp;<input type=\"submit\" value=\"Select/Then Click\">&nbsp;&nbsp;</td>\n";
print "<input type=hidden name=\"subject\" value=\"$ENV{'QUERY_STRING'}\">\n";
print "<input type=hidden name=\"thanksvar\" value=\"singlem\">\n";
print "</form>\n";
print "</tr>\n";
print "</table></center>\n";
print @footerw;
exit;
}


##########getrateitd

sub getrateitd {

     open (DATA, "<$DATAPATH/$ENV{'QUERY_STRING'}.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     print "Content-type:text/html\n\n";
     print @headerw;
     print "<center><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORW\"><b>$sdata[8]</b></font></center>\n";
print "<center><table><tr>\n";
print "<form action=\"$SCRIPTURL?govostar\" method=POST>\n";
print "<td colspan=\"5\" align=\"center\"><img src=\"$IMGPATH/five.$GIFO\" border=\"0\"><br><br></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"1\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"2\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"3\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"4\"></td>\n";
print "<td align=\"center\"><input type=\"radio\" name=\"rate\" value=\"5\"></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>1</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>2</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>3</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>4</b></font></td>\n";
print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZESM\"><b>5</b></font></td></tr>\n";
print "<tr>\n";
print "<td align=\"center\" colspan=\"5\" nowrap><br>&nbsp;&nbsp;<input type=\"submit\" value=\"Select/Then Click\">&nbsp;&nbsp;</td>\n";
print "<input type=hidden name=\"subject\" value=\"$ENV{'QUERY_STRING'}\">\n";
print "<input type=hidden name=\"thanksvar\" value=\"double\">\n";
print "</form>\n";
print "</tr>\n";
print "</table></center>\n";
print @footerw;
exit;
}

##########thanks
sub thanks {


     open (DATA, "<$DATAPATH/$FORM{'subject'}.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     print "Content-type:text/html\n\n";

     print @headerw;

     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"$FONTCOLORW\"><b>Your rating of<br><img src=\"$IMGPATH/$stargif.$GIFO\" border=\"0\"><br>has been added.</b></font></td></table></center>\n";

     print "<center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><br><br>$RETHANKST</b></font></center>\n";


if ($ASKWINDOW eq "yes") {
     print @footerw;
exit;
}


if ($FORM{'thanksvar'} eq "double") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL2?$FORM{'subject'}\">To $sdata[0]</a><br><br>\n";
     print "<a href=\"$SCRIPTURL\">$RELINK2</a></b></font></center>\n";
}
if ($FORM{'thanksvar'} eq "singlet") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL2?$FORM{'subject'}\">To $sdata[0]</a></b></font></center>\n";
}
if ($FORM{'thanksvar'} eq "singlem") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL\">$RELINK2</a></b></font></center>\n";
}

     print @footerw;

exit;
}

##########errorblank
sub errorblank {

     print "Content-type:text/html\n\n";

     print @headerw;

     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><br>You did not select a rating.<br><br>\n";
     print "<form><INPUT TYPE=\"Button\" VALUE=\"Back\" onClick=\"history.back()\"></form></b></font></td></table></center>\n";

     print @footerw;

exit;
  }
##########errorit
sub errorit {
     print "Content-type:text/html\n\n";

     print @headerw;

     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b>Invalid call to this script.</b></font></td></table></center>\n";

     print @footerw;

exit;
  }

##########errorfile
sub errorfile {

     print "Content-type:text/html\n\n";
     print "<html><body>\n";
     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEBIG\" color=\"black\"><b>File or Directory cannot be opened.<br><br>Default error message.</b></font></td></table></center>\n";
     print "</body></html>\n";

exit;
  }

##########errorvote
sub errorvote {

     open (DATA, "<$DATAPATH/$FORM{'subject'}.txt") || &errorfile;
@sdata = split (';', <DATA>);
close (DATA);

     print "Content-type:text/html\n\n";

     print @headerw;

     print "<center><table>\n";
     print "<td align=\"center\"><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b>$DOUBLEVOTE</b></font></td></table></center>\n";

if ($ASKWINDOW eq "yes") {
     print @footerw;
exit;
}


if ($FORM{'thanksvar'} eq "double") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL2?$FORM{'subject'}\">To $sdata[0]</a><br><br>\n";
     print "<a href=\"$SCRIPTURL\">$RELINK2</a></b></font></center>\n";
}
if ($FORM{'thanksvar'} eq "singlet") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL2?$FORM{'subject'}\">To $sdata[0]</a></b></font></center>\n";
}
if ($FORM{'thanksvar'} eq "singlem") {
     print "<br><br><center><font face=\"$FONTFACE\" size=\"$FONTSIZEMED\" color=\"$FONTCOLORW\"><b><a href=\"$SCRIPTURL\">$RELINK2</a></b></font></center>\n";
}

     print @footerw;

exit;
}